import sys
family=sys.argv[1]
SecurityLevel=int(sys.argv[2])
kappa=int(sys.argv[3])
lgA=float(sys.argv[4])
lgB=float(sys.argv[5])

gd=open("c-"+family+"-"+str(SecurityLevel)+"-"+str(kappa)+".txt","w")


def probabilistic_norm_bitsize(fg,h,lgA,N=1000):
    Q.<t,x>=QQ['t,x']
    eta=h.degree()
    A=ceil(2^lgA)    
    val=0
    for j in range(N):
        a=sum([randint(-A,A+1)*t^i for i in range(0,eta)])
        b=sum([randint(-A,A+1)*t^i for i in range(0,eta)])
        vali=log((a-b*x).resultant(fg(t,x),x).resultant(h(t,0),t),2).n().abs()
        if vali == infinity:
            continue
        val+=vali
    return val/N

def frange(x, y, jump):
  while x < y:
    yield x
    x += jump

def precise_tuning(SecurityLevel,eta,lgA,lgB):
    def eval_cost(A,B,probf,probg,auto=None):
        if auto == None:
            auto=eta*kappa/gcd(eta,kappa)
        lgB=log(B,2).n()
        if family == "KSS18" and kappa == 2:
            return 2*B/log(B)*(probf*probg)^(-1)/(kappa) +2^7*B^2/(lgB*kappa)^2/lg(B)^2 
        else:
            return 2*B/log(B)*(probf*probg)^(-1)/(auto) +2^7*B^2/(lgB*auto)^2/log(B)^2
    def min_in_abs_value(values):
        abs_values=map(abs,values)
        i=abs_values.index(min(abs_values))
        return values[i]
    Qx.<t,x>=QQ['t,x'] 
    h_is_not_set=true
    if family in ["k"+str(k)+"CocksPinch" for k in range(9,55)]: 
        gain =10
        k=int(family.split("C")[0].split("k")[1])
        r = next_prime(2*(2*SecurityLevel))
        q = next_prime(2^(4*SecurityLevel-gain))
        p=q
        embedding_degree=ZZ(k)
        eta=embedding_degree // kappa
        if kappa > 1:
            print "exTNFS-Conj"
            if gcd(kappa,eta) == 1:
                f = x^(2*kappa)+3  # representative
                g = randint(1,floor(sqrt(p)))*x^kappa - randint(1,floor(sqrt(p)))
                if eta >= 2:
                    h = t^eta - t + 1
                else:
                    h = t
            else:
                f = (x^kappa+t)^2+3  # representative      
                g = randint(1,floor(sqrt(p)))*(x^kappa+t) - randint(1,floor(sqrt(p)))
                h = t^eta - t + 1
            if kappa == 2:
                auto = 2
            else:
                auto = 1
        else: # kappa == 1:
            print "TNFS base-m"
            lgp = log(p,2).n()
            d = floor(sqrt(2*lgp/lgA))-1
            m=floor(p^(1/(d+1)))
            g = x-m
            f = sum([randint(1,m)*x^i for i in range(0,d+1)])
            h = t^eta-t-1
            auto = 1
        w = 1
        B=ceil(2^lgB)
        A=ceil(2^lgA)
        lgNf=probabilistic_norm_bitsize(f,h,lgA)
        lgNg=probabilistic_norm_bitsize(g,h,lgA)
        min_cost=eval_cost(A,B,dickman_rho(lgNf/lgB).n(),dickman_rho(lgNg/lgB).n(),auto)
        if not (2*A+1)^(2*eta)/2*dickman_rho(lgNf/lgB).n()*dickman_rho(lgNg/lgB)/w >=  2*B/log(B):
            print "lgA and lgB are incorrect"
            print log((2*A+1)^(2*eta)/2*dickman_rho(lgNf/lgB).n()*dickman_rho(lgNg/lgB)/w,2).n(), log(2*B/log(B),2).n()
            raise ValueError
        else:
            optimal_lgA=lgA
            optimal_lgB=lgB
            optimal_lgNf=lgNf
            optimal_lgNg=lgNg
            lgQ=log(q,2).n()*k
            for lgA_ in frange(lgA-0.2,lgA+1,0.2):
                lgNf=probabilistic_norm_bitsize(f,h,lgA)
                lgNg=probabilistic_norm_bitsize(g,h,lgA)
                A=ceil(2^lgA_)
                for lgB_ in frange(lgB-30,lgB+30,2):
                    B=ceil(2^lgB_) 
                    cost=eval_cost(A,B,dickman_rho(lgNf/lgB_).n(),dickman_rho(lgNg/lgB_).n(),auto)
                    if (2*A+1)^(2*eta)/2*dickman_rho(lgNf/lgB_).n()*dickman_rho(lgNg/lgB_)/(w) >=  2 * B/log(B) and cost < min_cost:
                        min_cost=cost
                        #print "exTNFS-Conj "+str(family)+" "+str(SecurityLevel)+": "+"new cost",log(min_cost,2).n()
                        optimal_lgA=lgA_
                        optimal_lgB=lgB_
                        optimal_lgNf=lgNf
                        optimal_lgNg=lgNg
    else:
        print "Unknown family" 
        #raise ValueError
    return optimal_lgA,optimal_lgB,log(min_cost,2).n(),optimal_lgNf,optimal_lgNg,lgQ

load taxonomyComplete.sage


def pad(x):
    s=str(RR(x).n(15))
    s=s+(11-len(s))*" "
    return s

optimal_lgA,optimal_lgB,s,lgNf,lgNg,lgQ=precise_tuning(SecurityLevel,eta,lgA,lgB)

gd.write(pad(lgQ)+pad(optimal_lgA)+pad(optimal_lgB)+pad(s)+pad(lgNf)+pad(lgNg))

