import sys

SecurityLevel=int(sys.argv[1])
kappa=int(sys.argv[2])

gd=open("DEM-"+str(SecurityLevel)+"-"+str(kappa)+".txt","w")
#ymod = ZZ(sys.argv[1])

from sage.libs.libecm import ecmfactor
def sieved(r,B=10^6):
    for p in primes(2,B):
        r /= p^valuation(r,p)
    r = ZZ(r)
    B1=11000 # https://members.loria.fr/pzimmermann/records/ecm/params.html
    nb_curves = 86 # see above 
    for sigma in range(10,10+nb_curves):
        result = ecmfactor(r,B1,sigma=sigma)
        if result[0] == true:
            r = r // result[1]
            if r == 1:
                break
    return r


def DEM(k,log_r,D=3,nb_trials=None):
    tmp=[]
    Z.<t,y> = ZZ[]
    e1 = cyclotomic_polynomial(k)(t-1)
    e2 = (D*y^2+t^2)+4*(1-t)
    R = e1.resultant(e2,t)
    Zy.<y> = ZZ[]
    R = Zy(R(1,y))
    y0min = (R-2^log_r).real_roots()[-1]
    if nb_trials == None:
        nb_trials = 2*y0min
    for y0 in range(y0min,y0min+nb_trials): 
        R0 = ZZ(R(y=y0))
        r = sieved(R0)
        if r.is_prime() and log(r,2) > 0.5 * log_r:
            for t_ in GF(r)['t'](e2(y=y0)).roots():
                t0,e = t_
                t0 = ZZ(t0)
                q = (D*y0^2+t0^2)/4
                q1 = q+1-t0
                if q in ZZ and q.is_prime():
                    tmp.append([y0,t0,q,r])
    return tmp

tmp=DEM(kappa,SecurityLevel,D=3,nb_trials=10^6)
gd.write(str(tmp))
                 

#Zx.<x>=ZZ[]
#D=3
#R = 81*x^8 + 162*x^6 + 99*x^4 - 18*x^2 + 1
#
#for y in range(2^17+ymod,2^17,20):
#    if y % 100 == 0:
#        print y
#        pass
#    r=sieved(ZZ(R(y)))
#    if r.is_prime() and legendre_symbol(-D*y^2,r) == 1:
#        t=2+sqrt(mod(-D*y^2,r)).lift()
#        q,r4=(D*y^2+t^2).quo_rem(4)
#        if r4 == 0 and q.is_prime():
#            if (q+1+t).is_prime():
#                print y,t,q,r
 
#DEM(12,128,D=3,nb_trials=None)


