import sys
family=sys.argv[1]
SecurityLevel=int(sys.argv[2])
kappa=int(sys.argv[3])
lgA=float(sys.argv[4])
lgB=float(sys.argv[5])


gd=open("g-"+family+"-"+str(SecurityLevel)+"-"+str(kappa)+".txt","w")


def probabilistic_norm_bitsize(fg,h,lgA,N=1500):
    Q.<t,x>=QQ['t,x']
    eta=h.degree()
    A=ceil(2^lgA)    
    val=0
    for j in range(N):
        a=sum([randint(-A,A+1)*t^i for i in range(0,eta)])
        b=sum([randint(-A,A+1)*t^i for i in range(0,eta)])
        vali=log((a-b*x).resultant(fg(t,x),x).resultant(h(t,0),t),2).n().abs()
        if vali == infinity:
            continue
        val+=vali
    return val/N

def frange(x, y, jump):
  while x < y:
    yield x
    x += jump

def precise_tuning(SecurityLevel,eta,lgA,lgB):
    def eval_cost(A,B,probf,probg,auto=None):
        if auto == None:
            auto=eta*kappa/gcd(eta,kappa)
        lgB=log(B,2).n()
        if family == "KSS18" and kappa == 2:
            return 2*B/log(B)*(probf*probg)^(-1)/(kappa) +2^7*B^2/(lgB*kappa)^2/lg(B)^2 
        else:
            return 2*B/log(B)*(probf*probg)^(-1)/(auto) +2^7*B^2/(lgB*auto)^2/log(B)^2
    def min_in_abs_value(values):
        abs_values=map(abs,values)
        i=abs_values.index(min(abs_values))
        return values[i]
    Qx.<t,x>=QQ['t,x'] 
    h_is_not_set=true
    if family in [ "k10method62","k11method62","k13method62","k14method62","k15method62","k17method62","k18method62","k19method62","k21method62","k22method62","k23method62","k25method62","k26method62","k27method62","k29method62","k30method62","k31method62","k33method62","k34method62","k35method62","k37method62","k38method62","k39method62","k41method62","k42method62","k43method62","k45method62","k46method62","k47method62","k49method62","k50method62","k51method62","k53method62","k54method62","k14method63","k18method63","k12method64","k20method64","k28method64","k36method64","k44method64","k52method64","k12method66","k13method66","k19method66","k14method66","k20method66","k15method66","k16method66","k11method66","k17method66","k19method66","k21method66","k24method67","k27method67","k30method67","k33method67","k36method67","k39method67","k42method67","k45method67","k48method67","k48method67","k51method67","k54method67","k9method67", "k12method67","k15method67","k18method67","k21method67","BN","k15method620","k19method620","k10method624","k18method624","KSS54","k10method63","k22method63","k26method63","k30method63","k34method63","k38method63","k42method63","k46method63","k50method63","k54method63","k22method66","k23method66","k24method66","k25method66","k26method66","k27method66","k28method66","k29method66","k30method66","k24method67","k27method67","k30method67","k11method620","k15method620","k26method624","k34method624","k16method611","k18method612","k32method613","k36method614","k36method615","k2rho1"]:
        r = rs[family]
        q = qs[family]
        k = ks[family]       
        P = Ps[family]
        v = vs[family]
        embedding_degree = k
        eta = k // kappa
        rbsize = 2*SecurityLevel
        x0bsize = ceil((rbsize + ceil(log(ZZ(r.denominator()),2)) ) / r.numerator().degree() )
        x0 = 2^x0bsize
        while ( not q(x0) in ZZ) or (not (ZZ(q(x0))).is_prime()):
            x0 += 1 
            if x0 % 100000 == 0:
                print x0
        p = ZZ(q(x0))
        print p
        lgQ = k * log(p,2).n()
        if lgA > 0:    # i.e. (exT)NFS
            if kappa > 1:
                print "exTNFS-JLSV"
                if gcd(kappa,eta) == 1:
                    f = x^kappa+2*randint(1,floor(sqrt(p)))  # representative
                    print p
                    g = randint(1,floor(sqrt(p)))*x^kappa - randint(1,floor(sqrt(p)))
                    print "ok"
                    if eta >= 2:
                        h = t^eta - t + 1
                    else:
                        h = t
                else:
                    f = (x^kappa+t)^2+3  # representative      
                    g = randint(1,floor(sqrt(p)))*(x^kappa+t) - randint(1,floor(sqrt(p)))
                    h = t^eta - t + 1
                if kappa == 2:
                    auto = 2
                else:
                    auto = 1
            else: # kappa == 1:
                print "TNFS base-m"
                lgp = log(p,2).n()
                d = floor(sqrt(2*lgp/lgA))-1
                m=floor(p^(1/(d+1)))
                g = x-m
                f = sum([randint(1,m)*x^i for i in range(0,d+1)])
                h = t^eta-t-1
                auto = 1
            w = 1
            eta=embedding_degree // kappa
            B=ceil(2^lgB)
            A=ceil(2^lgA)
            lgNf=probabilistic_norm_bitsize(f,h,lgA)
            lgNg=probabilistic_norm_bitsize(g,h,lgA)
            min_cost=eval_cost(A,B,dickman_rho(lgNf/lgB).n(),dickman_rho(lgNg/lgB).n(),auto)
            if not (2*A+1)^(2*eta)/2*dickman_rho(lgNf/lgB).n()*dickman_rho(lgNg/lgB)/w >=  2*B/log(B):
                print "lgA and lgB are incorrect"
                print log((2*A+1)^(2*eta)/2*dickman_rho(lgNf/lgB).n()*dickman_rho(lgNg/lgB)/w,2).n(), log(2*B/log(B),2).n()
                raise ValueError
            else:
                optimal_lgA=lgA
                optimal_lgB=lgB
                optimal_lgNf=lgNf
                optimal_lgNg=lgNg
                for lgA_ in frange(lgA-10,lgA+10,1):
                    lgNf=probabilistic_norm_bitsize(f,h,lgA)
                    lgNg=probabilistic_norm_bitsize(g,h,lgA)
                    A=ceil(2^lgA_)
                    for lgB_ in frange(lgB-30,lgB+30,2):
                        B=ceil(2^lgB_) 
                        cost=eval_cost(A,B,dickman_rho(lgNf/lgB_).n(),dickman_rho(lgNg/lgB_).n(),auto)
                        if (2*A+1)^(2*eta)/2*dickman_rho(lgNf/lgB_).n()*dickman_rho(lgNg/lgB_)/(w) >=  2 * B/log(B) and cost < min_cost:
                            min_cost=cost
                            print "new cost",log(min_cost,2).n()
                            optimal_lgA=lgA_
                            optimal_lgB=lgB_
                            optimal_lgNf=lgNf
                            optimal_lgNg=lgNg
        else:   # lgA==0 i.e. Index Calculus
            optimal_lgB = lgB
            optimal_lgA = lgA
            optimal_lgNf = lgQ * 0.5
            optimal_lgNg = lgQ * 0.5
            min_cost = infinity
            def IndexCalculusCost(lgB,lgQ):
                B=2^lgB
                cost = infinity
                return 2^lgB/(lgB/log(e,2))*dickman_rho(lgQ/(2*lgB))^(-2)+2^7*(2^lgB/(lgB^2/log(e,2)))^2  
            for lgB_ in frange(lgB-30,lgB+30,3):        
                cost = IndexCalculusCost(lgB_,lgQ)
                if cost < min_cost:
                    min_cost=cost
                    print "new cost",log(min_cost,2).n()
                    optimal_lgB=lgB_
    else:
        print "Unknown family" 
        #raise ValueError
    return optimal_lgA,optimal_lgB,log(min_cost,2).n(),optimal_lgNf,optimal_lgNg,lgQ

load taxonomyComplete.sage

optimal_lgA,optimal_lgB,s,lgNf,lgNg,lgQ=precise_tuning(SecurityLevel,eta,lgA,lgB)
def pad(x):
    s=str(RR(x).n(15))
    s=s+(11-len(s))*" "
    return s


gd.write(pad(lgQ)+pad(optimal_lgA)+pad(optimal_lgB)+pad(s)+pad(lgNf)+pad(lgNg))

