#!/bin/bash
families=`cat families.txt`
security_levels="128 192 256"
touch empty.txt
texFile="table-security.tex"
echo "" > $texFile

for family in `echo $families`; do
    echo "Writing $family."
    echo "$family " >> $texFile
    for securityLevel in ${security_levels}; do
        field_side_security=1000 # infinity
        best_results_file=empty.txt # infinity
        for resultsFile in `ls [pcgqdh]-${family}-${securityLevel}-*.txt 2>/dev/null` ; do
            fileSecurity=`cat $resultsFile | tr -s " " | cut -f4 -d" " | cut -f1 -d"."` 
            if [ ! -z "$fileSecurity" ]; then

                algoIndicator=`echo $best_results_file | cut -f1 -d"." | cut -f1 -d"-" `
                if (( $fileSecurity < $field_side_security || $algoIndicator == "q" || $algoIndicator == "d" ||  $algoIndicator == "h" )); then
                    field_side_security=$fileSecurity
                    best_results_file=$resultsFile
                fi
            fi
        done
        algoIndicator=`echo $best_results_file | cut -f1 -d"." | cut -f1 -d"-" `
        fieldBitSize=`cat $best_results_file | cut -f1 -d" " `
        kappa=`echo $best_results_file | cut -f1 -d"." | cut -f4 -d "-"`
        case "$algoIndicator" in
             "p"|"q") case $kappa in
                    1) echo "& $fieldBitSize $field_side_security SNFS k=1 ">> $texFile  ;;
                    *) echo "& $fieldBitSize $field_side_security SexTNFS k=$kappa ">> $texFile
                   esac ;;
             "c"|"d") case $kappa in 
                    1) echo "& $fieldBitSize $field_side_security TNFS-base m k=1 ">> $texFile ;;
                    *) echo "& $fieldBitSize $field_side_security exTNFS-Conj k=$kappa ">> $texFile ;;
                   esac ;;
             "g"|"h") echo "& $fieldBitSize $field_side_security exTNFS-GJL k=$kappa ">> $texFile ;;
              *)  echo "& TODO ">> $texFile
        esac      
        #sleep 2
    done
    echo "\\\\" >> $texFile
done 

echo "\end{tabular}" >> $texFile
