
# This file was *autogenerated* from the file p.sage
from sage.all_cmdline import *   # import sage library

_sage_const_3 = Integer(3); _sage_const_2 = Integer(2); _sage_const_1 = Integer(1); _sage_const_0 = Integer(0); _sage_const_7 = Integer(7); _sage_const_6 = Integer(6); _sage_const_5 = Integer(5); _sage_const_4 = Integer(4); _sage_const_8 = Integer(8); _sage_const_28 = Integer(28); _sage_const_22 = Integer(22); _sage_const_20 = Integer(20); _sage_const_24 = Integer(24); _sage_const_40 = Integer(40); _sage_const_42 = Integer(42); _sage_const_18 = Integer(18); _sage_const_46 = Integer(46); _sage_const_48 = Integer(48); _sage_const_0p1 = RealNumber('0.1'); _sage_const_12 = Integer(12); _sage_const_11 = Integer(11); _sage_const_10 = Integer(10); _sage_const_1000 = Integer(1000); _sage_const_15 = Integer(15); _sage_const_30 = Integer(30); _sage_const_32 = Integer(32); _sage_const_52 = Integer(52); _sage_const_36 = Integer(36); _sage_const_100 = Integer(100); _sage_const_16 = Integer(16)
import sys
algo=sys.argv[_sage_const_1 ]
family=sys.argv[_sage_const_2 ]
SecurityLevel=int(sys.argv[_sage_const_3 ])
kappa=int(sys.argv[_sage_const_4 ])
lgA=float(sys.argv[_sage_const_5 ])
lgB=float(sys.argv[_sage_const_6 ])


sage.repl.load.load(sage.repl.load.base64.b64decode("dGF4b25vbXlDb21wbGV0ZS5zYWdl"),globals(),False)

"""
given a polynomial h and a polynomial fg (i.e. f or g) and log_2(A), it computes the binary size of the norm of a(t)-x*b(t) where a(t) and b(t) are random polynomials with coefficients less than A and degree less than deg(h) 
"""
def probabilistic_norm_bitsize(fg,h,lgA,N=_sage_const_3 *_sage_const_1000 ):
    Q = QQ['t,x']; (t, x,) = Q._first_ngens(2)
    eta=h.degree()
    A=ceil(_sage_const_2 **lgA)    
    val=_sage_const_0 
    for j in range(N):
        a=sum([randint(-A,A+_sage_const_1 )*t**i for i in range(_sage_const_0 ,eta)])
        b=sum([randint(-A,A+_sage_const_1 )*t**i for i in range(_sage_const_0 ,eta)])
        val+=log((a-b*x).resultant(fg(t,x),x).resultant(h(t,_sage_const_0 ),t),_sage_const_2 ).n().abs()
    return val/N


"""
for in the set {z=x+i*jump : z < y}
"""
def frange(x, y, jump):
    while x < y:
        yield x
        x += jump


def polyselect(algo,eta,kappa,P,v,x0,p):
    #print "eta=",eta
    #print "kappa=",kappa    

    # construct f,g
    Q = QQ['t,x']; (t, x,) = Q._first_ngens(2)
    if algo == "SexTNFS":
        print "SexTNFS"
        if gcd(eta,kappa) == _sage_const_1 :
            f = P(x=x**kappa)       
            g = x**kappa-v(x=x0)
        else:
            f = P(x=x**kappa+t)
            g = x**kappa+t-v(x=x0)
        if kappa == _sage_const_2 :
            auto = _sage_const_2 
        else:
            auto = _sage_const_1 
    elif algo in ["exTNFS-Conj","exTNFS-GJL"] and kappa == _sage_const_1 :
        print "TNFS base-m"
        lgp = log(p,_sage_const_2 ).n()
        d = k # floor(sqrt(2*lgp/lgA))-1
        m=floor(p**(_sage_const_1 /(d+_sage_const_1 )))
        g = x-m
        f = sum([randint(_sage_const_1 ,m)*x**i for i in range(_sage_const_0 ,d+_sage_const_1 )])
        auto = _sage_const_1 
    elif algo == "exTNFS-Conj":
        print "exTNFS-Conj"
        v = randint(floor(sqrt(p))//_sage_const_2 , floor(sqrt(p)))
        u = randint(floor(sqrt(p))//_sage_const_2 , floor(sqrt(p)))
        if gcd(eta,kappa) == _sage_const_1 :
            f = x**(_sage_const_2 *kappa)+_sage_const_3   # representative
            g = v*(x**kappa) - u
        else:
            f = x**(_sage_const_2 *kappa)+_sage_const_3 +t
            g = v*(x**kappa+t) - u
        if kappa == _sage_const_2 :
            auto = _sage_const_2 
        else:
            auto = _sage_const_1 
    elif algo == "exTNFS-GJL":
        print "exTNFS-gJL"
        ng = ceil(p**(kappa/(kappa+_sage_const_1 )))
        f = x**(kappa+_sage_const_1 )+sum([randint(-_sage_const_1 ,_sage_const_1 )*x**i for i in range(kappa+_sage_const_1 )])  
        g = sum([randint(-ng,ng)*x**i for i in range(kappa+_sage_const_1 )])
        if gcd(eta,kappa) != _sage_const_1 :
            f = f(x=x+t)
            g = g(x=x+t)
        auto = _sage_const_1 

    # construct h 

    if eta == _sage_const_1 :
        h = t
        auto *= _sage_const_1 
        w=_sage_const_1 
    elif eta in [_sage_const_6 ,_sage_const_8 ,_sage_const_10 ,_sage_const_12 ,_sage_const_16 ,_sage_const_18 ,_sage_const_20 ,_sage_const_22 ,_sage_const_24 ,_sage_const_28 ,_sage_const_30 ,_sage_const_32 ,_sage_const_36 ,_sage_const_40 ,_sage_const_42 ,_sage_const_46 ,_sage_const_48 ,_sage_const_52 ]:
        ck = min([ck1 for ck1 in range(_sage_const_7 ,_sage_const_100 ) if euler_phi(ck1) == eta])
        h=cyclotomic_polynomial(ck)(t)
        auto *= eta
        w=floor(ck/_sage_const_2 )
    else:
        h = t**eta - t + _sage_const_1 
        auto *= _sage_const_1 
        w = _sage_const_1 

    return f,g,h,auto,w



"""
main function
given a security level on the curve side, a family, a parameter eta, log_2(A),log_2(B), it selects the polynomial f,g,h and it optimizes log_2(A) and log_2(B) locally around the given values, which must be valid parameters
"""
def precise_tuning(SecurityLevel,eta,lgA,lgB):


    # read family in taxonomy
    Qx = QQ['t,x']; (t, x,) = Qx._first_ngens(2)
    if not family in rs.keys(): 
        print "Unknown family" 
        #raise ValueError
    r = rs[family]
    q = qs[family]
    k = ks[family]       
    P = Ps[family]
    v = vs[family]
    embedding_degree = k
    eta = k // kappa


    # find the smallest numerical example of elliptic curve
    # in the family which has the required security on the curve side 
    rbsize = _sage_const_2 *SecurityLevel
    x0bsize = ceil((rbsize + ceil(log(ZZ(r.denominator()),_sage_const_2 )) ) / r.numerator().degree() )
    x0 = _sage_const_2 **x0bsize
    while ( not q(x0) in ZZ) or (not (ZZ(q(x0))).is_prime()):
        x0 += _sage_const_1  
        if x0 % _sage_const_10 **_sage_const_6  == _sage_const_0 :
            print x0
    p = ZZ(q(x0))
    lgQ = k * log(p,_sage_const_2 ).n()


    f,g,h,auto,w = polyselect(algo,eta,kappa,P,v,x0,p)
    print f,g,h
    

    # test if (S)exTNFS succeeds with these parameters
    A=ceil(_sage_const_2 **lgA)
    B=ceil(_sage_const_2 **lgB)
    gNf=probabilistic_norm_bitsize(f,h,lgA)
    gNg=probabilistic_norm_bitsize(g,h,lgA)


    def eval_cost(A,B,probf,probg,auto=None):
        if auto == None:
            auto=eta*kappa/gcd(eta,kappa)
        lgB=log(B,_sage_const_2 ).n()
        if family == "KSS18" and kappa == _sage_const_2 :
            return _sage_const_2 *B/log(B)*(probf*probg)**(-_sage_const_1 )/(kappa) +_sage_const_2 **_sage_const_7 *B**_sage_const_2 /(lgB*kappa)**_sage_const_2 /lg(B)**_sage_const_2  
        else:
            return _sage_const_2 *B/log(B)*(probf*probg)**(-_sage_const_1 )/(auto) +_sage_const_2 **_sage_const_7 *B**_sage_const_2 /(lgB*auto)**_sage_const_2 /log(B)**_sage_const_2 

   
    # abort if the default parameters were wrong
    lgNf=probabilistic_norm_bitsize(f,h,lgA)
    lgNg=probabilistic_norm_bitsize(g,h,lgA)
    #print lgNf,lgNg

    min_cost=eval_cost(A,B,dickman_rho(lgNf/lgB).n(),dickman_rho(lgNg/lgB).n(),auto)
    if not ((_sage_const_2 *A+_sage_const_1 )**(_sage_const_2 *eta)/_sage_const_2 *dickman_rho(lgNf/lgB).n()*dickman_rho(lgNg/lgB)/w >=  _sage_const_2 *B/log(B)):
       print "lgA and lgB are incorrect"
       print log((_sage_const_2 *A+_sage_const_1 )**(_sage_const_2 *eta)/_sage_const_2 *dickman_rho(lgNf/lgB).n()*dickman_rho(lgNg/lgB)/w,_sage_const_2 ).n(), log(_sage_const_2 *B/log(B),_sage_const_2 ).n()
       raise ValueError


    # locally optimize lgA and lgB
    optimal_lgA=lgA
    optimal_lgB=lgB
    optimal_lgNf=lgNf
    optimal_lgNg=lgNg
    for lgA_ in frange(lgA-_sage_const_0p1 ,lgA+_sage_const_0p1 ,_sage_const_0p1 ):
        lgNf=probabilistic_norm_bitsize(f,h,lgA)
        lgNg=probabilistic_norm_bitsize(g,h,lgA)
        #print lgNf,lgNg
        A=ceil(_sage_const_2 **lgA_)
        for lgB_ in frange(lgB-_sage_const_1 ,lgB+_sage_const_1 ,_sage_const_0p1 ):
            B=ceil(_sage_const_2 **lgB_) 
            cost=eval_cost(A,B,dickman_rho(lgNf/lgB_).n(),dickman_rho(lgNg/lgB_).n(),auto)
            #print log(cost,2).n()
            if (_sage_const_2 *A+_sage_const_1 )**(_sage_const_2 *eta)/_sage_const_2 *dickman_rho(lgNf/lgB_).n()*dickman_rho(lgNg/lgB_)/(w) >=  _sage_const_2  * B/log(B) and cost < min_cost:
                min_cost=cost
                print algo+" "+str(family)+" "+str(SecurityLevel)+": "+"new cost",log(min_cost,_sage_const_2 ).n()
                optimal_lgA=lgA_
                optimal_lgB=lgB_
                optimal_lgNf=lgNf
                optimal_lgNg=lgNg

    return optimal_lgA,optimal_lgB,log(min_cost,_sage_const_2 ).n(),optimal_lgNf,optimal_lgNg,lgQ


"""
pretty print function
"""
def pad(x):
    s=str(RR(x).n(_sage_const_15 ))
    s=s+(_sage_const_11 -len(s))*" "
    return s



###### MAIN COMPUTATIONS


optimal_lgA,optimal_lgB,s,lgNf,lgNg,lgQ=precise_tuning(SecurityLevel,eta,lgA,lgB)


if algo == "SexTNFS":
    marker = "p"
elif algo == "exTNFS-Conj":
    marker = "c"
elif algo == "exTNFS-GJL":
    marker = "g"
else:
    raise ValueError

gd = open(marker+"-"+family+"-"+str(SecurityLevel)+"-"+str(kappa)+".txt","w")
gd.write(pad(lgQ)+pad(optimal_lgA)+pad(optimal_lgB)+pad(s)+pad(lgNf)+pad(lgNg))


