﻿#!/bin/bash
families=`cat families.txt`
security_levels="128 192 256"
touch empty.txt
htmlFile="params/security.html"
echo "<html>\n<body>\n<center>\n<table cellspacing=10>\n" > $htmlFile


for family in `echo $families`; do
    echo "Working on $family."
    echo "<tr><td><a href=\"$family.txt\">$family</a></td>" >> $htmlFile
    file=params/${family}.txt
    rm $file
    touch $file
    r=$(grep -m1 -e  "r_$family" taxonomyComplete.sage | cut -d"=" -f2)
    echo r=$r >> $file
    q=$(grep -m1 -e  "q_$family" taxonomyComplete.sage | cut -d"=" -f2)
    echo q=$q >> $file
    P=$(grep -m1 -e "P_$family" taxonomyComplete.sage | cut -d"=" -f2)
    echo P=$P >> $file
    v=$(grep -m1 -e "vs.update({\"$family" taxonomyComplete.sage | cut -d":" -f2 | cut -d"}" -f 1)
    echo v=$v >> $file
    for securityLevel in ${security_levels}; do
        echo "curve_side_security=${securityLevel}" >> $file
        field_side_security=1000 # infinity
        best_results_file=empty.txt # infinity
        for resultsFile in `ls [pcgqdh]-${family}-${securityLevel}-*.txt 2>/dev/null` ; do
            fileSecurity=`cat $resultsFile | tr -s " " | cut -f4 -d" " | cut -f1 -d"."` 
            if [ ! -z "$fileSecurity" ]; then

                algoIndicator=`echo $best_results_file | cut -f1 -d"." | cut -f1 -d"-" `
                if (( $fileSecurity < $field_side_security || $algoIndicator == "q" || $algoIndicator == "d" ||  $algoIndicator == "h" )); then
                    field_side_security=$fileSecurity
                    best_results_file=$resultsFile
                fi
            fi
        done
        echo "field_side_security=$field_side_security" >> $file
        echo "best_results_file=$best_results_file"  >> $file
        echo "best parametes :"  >> $file
        cat $best_results_file >> $file
        echo "" >> $file
        algoIndicator=`echo $best_results_file | cut -f1 -d"." | cut -f1 -d"-" `
        fieldBitSize=`cat $best_results_file | cut -f1 -d" " `
        kappa=`echo $best_results_file | cut -f1 -d"." | cut -f4 -d "-"`
        case "$algoIndicator" in
             "p"|"q") case $kappa in
                    1) echo "<td>$fieldBitSize $field_side_security SNFS k=1</td>">> $htmlFile  ;;
                    *) echo "<td>$fieldBitSize $field_side_security SexTNFS k=$kappa </td>">> $htmlFile
                   esac ;;
             "c"|"d") case $kappa in 
                    1) echo "<td>$fieldBitSize $field_side_security TNFS-base m k=1 </td>">> $htmlFile ;;
                    *) echo "<td>$fieldBitSize $field_side_security exTNFS-Conj k=$kappa </td>">> $htmlFile ;;
                   esac ;;
             "g"|"h") echo "<td>$fieldBitSize $field_side_security exTNFS-JLSV </td>">> $htmlFile ;;
              *)  echo "<td>TODO</td>">> $htmlFile
        esac      
        #sleep 2
    done
    echo "</tr>\n" >> $htmlFile
done 

echo "</table>\n</center>\n</body>\n</html>" >> $htmlFile
