﻿#!/bin/bash
families=`cat families.txt`
security_levels="128 192 256"
for family in `echo $families`; do
    echo "Preparing $family."
    for securityLevel in `echo ${security_levels}`; do
       rm [qdh]-$family-$securityLevel-*.txt 2>/dev/null
       found="false"
       realSecurity=${securityLevel}
#       while [ $found == "false" && $realSecurity -lt `expr $securityLevel + 10` ];do
        while [ $realSecurity -lt `expr $securityLevel + 10` ] && [ $found == "false" ];do
           good_files=`grep -e " ${realSecurity}[ .]" [pcg]-$family-*-*.txt 2>/dev/null | cut -f1 -d ":"`
           largestBitSize=1 # minimum
           best_results_file=empty.txt # infinity
           for resultsFile in $good_files ; do
                fieldBitSize=`cat $resultsFile | tr -s [:blank:] | cut -f1 -d" " | cut -f1 -d"."` 
                checkSecurity=`cat $resultsFile | tr -s [:blank:] | cut -f4 -d" " | cut -f1 -d"."` 
                if [ ! -z $fieldBitSize ] && [ ! -z $checksecurity ] && [ $checkSecurity == $realSecurity ]; then
                    if (( $fieldBitSize > $largestBitSize )); then
                        largestBitSize=$fieldBitSize
                        best_results_file=$resultsFile
                        found="true"
                    fi
                fi
            done
        realSecurity=`expr $realSecurity + 1`
        done
        if [ $found == "true" ]; then 
            algoIndicator=`echo $best_results_file | cut -f1 -d"." | cut -f1 -d"-" `
            curveSideSecurity=`echo $best_results_file | cut -f1 -d"." | cut -f3 -d"-"`
            fieldBitSize=`cat $best_results_file | cut -f1 -d" "`
            kappa=`echo $best_results_file | cut -f1 -d"." | cut -f4 -d "-"`
            case "$algoIndicator" in
                 "p") newfile="q-$family-$securityLevel-$kappa.txt";   cat $best_results_file > $newfile; echo "   $curveSideSecurity" >> $newfile; ;;
                 "c") newfile="d-$family-$securityLevel-$kappa.txt";   cat $best_results_file > $newfile; echo "   $curveSideSecurity" >> $newfile; ;;
                 "g") newfile="h-$family-$securityLevel-$kappa.txt";   cat $best_results_file > $newfile; echo "   $curveSideSecurity" >> $newfile; ;;
            esac      
        fi
    done
done 
