P.<x> = QQ[]
rs = {}
qs = {}
ks = {}
Ps = {}
vs = {}  # q = P(v), up to a scalar constant 


# we only check for elliptic curves with nice embedding degree at the 128 bits security level
# i.e. k = 9, 10, ..., 54
# for k = 11, 13, 17, 19 there is no nice arithmetic, but if we found very short expression for optimal Ate pairing, maybe it can be interesting to investigate a little more on those curves


# ----------------curves not belonging to the any family, no polynomial form---
for k in range(1,9):
    fam = "k"+str(k)+"rho1"
    rs.update({fam :  x})
    qs.update({fam :  x})
    ks.update({fam :  k})
    Ps.update({fam :  x})
    vs.update({fam :  x}) 


#------------------------------------MNT -- Section 5.1 ------------------------

# MNT 3  
t_k3MNT = -1+6*x 
r_k3MNT = 12*x^2 - 6*x + 1                                    
q_k3MNT = 12*x^2-1 
P_k3MNT = 3*x^2-1 
rs.update({"k3MNT" :  r_k3MNT})
qs.update({"k3MNT" :  q_k3MNT})
ks.update({"k3MNT" :  3})
Ps.update({"k3MNT" : P_k3MNT})
vs.update({"k3MNT" : 2*x}) 


# MNT 4  
t_k4MNT = x + 1 
r_k4MNT = x^2+1                                    
q_k4MNT = x^2 + x + 1 
P_k4MNT =  x^2 + x + 1
rs.update({"k4MNT" :  r_k4MNT})
qs.update({"k4MNT" :   P_k4MNT})
ks.update({"k4MNT" :  4})
Ps.update({"k4MNT" : x})
vs.update({"k4MNT" : x}) 


# MNT 6 
t_k6MNT = 1+2*x 
r_k6MNT = 4*x^2-2*x+1                                    
q_k6MNT = 4*x^2 + 1 
P_k6MNT =  x^2 + 1
rs.update({"k6MNT" :  r_k6MNT})
qs.update({"k6MNT" :   P_k6MNT})
ks.update({"k6MNT" :  6})
Ps.update({"k6MNT" : x})
vs.update({"k6MNT" : 2*x}) 





#------------- Duan Cui Chand D=3 ----------------------------------------------

# k=12 D=3 rho=1.5 
t_k12methodDCC = x + 1
r_k12methodDCC = x^4 - x^2 + 1 
q_k12methodDCC = (4*x^6 - 8*x^5 + 8*x^3 - x^2 + 2*x + 3)/8
P_k12methodDCC = 4*x^6 - 8*x^5 + 8*x^3 - x^2 + 2*x + 3
rs.update({"k12methodDCC" : r_k12methodDCC})
qs.update({"k12methodDCC" : q_k12methodDCC})
ks.update({"k12methodDCC" :  12})
Ps.update({"k12methodDCC" : P_k12methodDCC})
vs.update({"k12methodDCC" : x}) 



# k=15 D=3  rho=1.5 
t_k15methodDCC = x + 1
r_k15methodDCC = x^8 - x^7 + x^5 - x^4 + x^3 - x + 1 
q_k15methodDCC = (4*x^12-8*x^11+4*x^10+4*x^7-8*x^6+4*x^5+3*x^2+2*x+3)/8
P_k15methodDCC = 4*x^12-8*x^11+4*x^10+4*x^7-8*x^6+4*x^5+3*x^2+2*x+3
rs.update({"k15methodDCC" : r_k15methodDCC})
qs.update({"k15methodDCC" : q_k15methodDCC})
ks.update({"k15methodDCC" :  15})
Ps.update({"k15methodDCC" : P_k15methodDCC})
vs.update({"k15methodDCC" : x}) 


# k=24 D=3 rho=1.25 
t_k24methodDCC = x + 1
r_k24methodDCC = x^8 - x^4 + 1  
q_k24methodDCC = (4*x^10-8*x^9+4*x^8-4*x^6+8*x^5-4*x^4+3*x^2+2*x+3)/8 
P_k24methodDCC = 4*x^10-8*x^9+4*x^8-4*x^6+8*x^5-4*x^4+3*x^2+2*x+3
rs.update({"k24methodDCC" : r_k24methodDCC})
qs.update({"k24methodDCC" : q_k24methodDCC})
ks.update({"k24methodDCC" :  24})
Ps.update({"k24methodDCC" : P_k24methodDCC})
vs.update({"k24methodDCC" : x}) 



# k=48 D=3  rho=1.125.
t_k48methodDCC = x + 1
r_k48methodDCC = x^16 - x^8 + 1
q_k48methodDCC = (4*x^18-8*x^17+4*x^16-4*x^10+8*x^9-4*x^8+3*x^2+2*x+3)/8
P_k48methodDCC = 4*x^18-8*x^17+4*x^16-4*x^10+8*x^9-4*x^8+3*x^2+2*x+3
rs.update({"k48methodDCC" : r_k48methodDCC})
qs.update({"k48methodDCC" : q_k48methodDCC})
ks.update({"k48methodDCC" :  48})
Ps.update({"k48methodDCC" : P_k48methodDCC})
vs.update({"k48methodDCC" : x}) 



#-------------Freeman's k=10 method 5.3 and generalizations---------------------

# Drylo
k = 9
t_k9method53 = 243*x^5 + 1 
r_k9method53 = 729*x^6 + 27*x^3 + 1                                  
q_k9method53 = (59049*x^10 + 6561*x^9 + 8748*x^8 + 2916*x^7 + 972*x^6 + 1296*x^5 +108*x^4 + 36*x^3 + 12*x^2 + x + 1) / 4
P_k9method53 = 3*x^5 + x^4 - 11*x^3 + 7*x + 10 
rs.update({"k9method53" :  r_k9method53})
qs.update({"k9method53" :   q_k9method53})
ks.update({"k9method53" :  9})
Ps.update({"k9method53" : P_k9method53})
vs.update({"k9method53" : 3*x+1/(3*x)}) 


# LZZW k=9
t_k9methodLZZW = x + 1
r_k9methodLZZW = x^6 + x^3 + 1 
q_k9methodLZZW = ((x+1)^2+((x-1)^2*(2*x^3+1)^2)/3)/4
P_k9methodLZZW = (3*(x+1)^2+(x-1)^2*(2*x^3+1)^2)//4
rs.update({"k9methodLZZW" :  r_k9methodLZZW})
qs.update({"k9methodLZZW" :   q_k9methodLZZW})
ks.update({"k9methodLZZW" :  9})
Ps.update({"k9methodLZZW" : P_k9methodLZZW})
vs.update({"k9methodLZZW" : x }) 


# LZZW k=27


# Freeman
k = 10
t_k10method53 = 10*x^2+5*x+3
r_k10method53 = 25*x^4 + 25*x^3 + 15*x^2 + 5*x + 1
q_k10method53 = 25*x^4 + 25*x^3 + 25*x^2 + 10*x +3 
P_k10method53 =  q_k10method53
rs.update({"k10method53" :  r_k10method53})
qs.update({"k10method53" :   q_k10method53})
ks.update({"k10method53" :  10})
Ps.update({"k10method53" : P_k10method53})
vs.update({"k10method53" : x}) 


# Drylo
k = 12
t_k12method53 = (-x^3 + 4*x^2 + 5*x + 6) / 15 
r_k12method53 = x^4 - 2*x^3 - 3*x^2 + 4*x + 13 
q_k12method53 = (x^6 - 8*x^5 + 18*x^4 - 56*x^3 + 202*x^2 + 258*x - 423) / 900 
P_k12method53 =  q_k12method53.numerator()
rs.update({"k12method53" :  r_k12method53})
qs.update({"k12method53" :   q_k12method53})
ks.update({"k12method53" :  12})
Ps.update({"k12method53" : P_k12method53})
vs.update({"k12method53" : x}) 


# Drylo
k = 15
t_k15method53 = 9*x^2 + 1            
r_k15method53 = 6561*x^8 - 2187*x^7 + 243*x^5 - 81*x^4 + 27*x^3 - 3*x + 1 
q_k15method53 = (531441*x^13 - 236196*x^11 + 39366*x^10 + 39366*x^9 - 8748*x^8 - 729*x^7 + 486*x^6 - 243*x^5 + 135*x^4 + 18*x^3 + 18*x^2 + x + 1) / 4
P_k15method53 = x^13 - 4*x^11 + 2*x^10 + 6*x^9 - 4*x^8 - x^7 + 2*x^6 - 3*x^5 + 5*x^4 + 2*x^3 + 6*x^2 + x + 3 
rs.update({"k15method53" :  r_k15method53})
qs.update({"k15method53" :   q_k15method53})
ks.update({"k15method53" :  15})
Ps.update({"k15method53" : P_k15method53})
vs.update({"k15method53" : 3*x}) 


# Drylo
k = 28
t_k28method53 = 512*x^9 + 1                     
r_k28method53 = 4096*x^12 -  1024*x^10 + 256*x  - 64*x^6 + 16*x^4 - 4*x^2 + 1 
q_k28method53 = (262144*x^18 + 65536*x^17 -  32768*x^15 + 16384*x^14 + 12288*x^13 - 3072*x^11 + 2816*x^8 - 192*x^7 + 48*x^5 + 16*x^4 - 8*x^3 + x + 1) / 4
P_k28method53 =  2*x^18 + x^17 - 2*x^15 + 2*x^14 + 3*x^13 - 3*x^11 + 22*x^8 - 3*x^7 + 3*x^5 + 2*x^4 - 2*x^3 + x + 2
rs.update({"k28method53" :  r_k28method53})
qs.update({"k28method53" :   q_k28method53})
ks.update({"k28method53" :  28})
Ps.update({"k28method53" : P_k28method53})
vs.update({"k28method53" : 2*x}) 


# Drylo
k = 30
t_k30method53 = 25*x^2 + 1                    
r_k30method53 = 390625*x^8 + 78125*x^7 -  3125*x^5  - 625*x^4 - 125*x^3 + 5*x + 1 
q_k30method53 = (244140625*x^13 +195312500*x^12 +78125000*x^11 + 19531250*x^10 +2343750*x^9 - 140625*x^7  - 43750*x^6 - 6875*x^5 - 125*x^4 + 150*x^3 - 50*x^2 + 9*x + 1) / 4
P_k30method53 = x^13 + 4*x^12 + 8*x^11 + 10*x^10 + 6*x^9 - 9*x^7 - 14*x^6 - 11*x^5 - x^4 + 6*x^3 - 10*x^2 + 9*x + 5
rs.update({"k30method53" :  r_k30method53})
qs.update({"k30method53" :   q_k30method53})
ks.update({"k30method53" :  30})
Ps.update({"k30method53" : P_k30method53})
vs.update({"k30method53" : 5*x}) 


#----------------------------------k arbitrary  method 6.2----------------------------
# Code magma 
#k = odd, D=1, deg(r(x))= 2 phi(k), rho = (k+2)/phi(k), 
# courbes potentiel k_prime= 2k, 
#r(x) = CyclotomicPolynomial(4*k)
#q(x) = (x^(2*k+4) + 2*x^(2*k+2) + x^(2*k) + x^4 - 2*x^2 + 1) / 4
#t(x) = -x^2 + 1
# we can construct k = 14 (2x7), 13, 15, 17, 18 (2x9), 19
#Q = RationalField()
#P<x> = PolynomialRing(Q)
#k =13
#(k+2.)/EulerPhi(k)
#CyclotomicPolynomial(4*k)
#q = (x^(2*k+4) + 2*x^(2*k+2) + x^(2*k) + x^4 - 2*x^2 + 1) / 4
#q
#Degree(q)

k = 9
# rho = 1.834
r_k9method62 = x^12 - x^6 + 1  
q_k9method62 = x^22 + 3*x^20 + x^18 + x^4 - 2*x^2 + 1
P_k9method62 = x^11 + 3*x^10 + x^9 + x^2 -2*x + 1
t_k9method62 = -x^2 + 1
rs.update({"k9method62" :  r_k9method62})
qs.update({"k9method62" :   q_k9method62})
ks.update({"k9method62" :  9})
Ps.update({"k9method62" : P_k9method62})
vs.update({"k9method62" : x^2}) 



# k = 10
# k0 = 5, D=1, rho = 1.75,
r_k10method62 = x^8 - x^6 + x^4 - x^2 + 1
q_k10method62 = (x^14 + 2*x^12 + x^10 + x^4 - 2*x^2 + 1) / 4
P_k10method62 = x^7 + 2*x^6+x^5+x^2-2*x+1
t_k10method62 = -x^2 + 1
rs.update({"k10method62" :  r_k10method62})
qs.update({"k10method62" :   q_k10method62})
ks.update({"k10method62" :  10})
Ps.update({"k10method62" : P_k10method62})
vs.update({"k10method62" : x^2}) 


# k = 11
# k = 11, D=1, deg(r(x))= 20, rho = 1.30,
# deg(r) = 20, deg(q) = 26
r_k11method62 =x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1
q_k11method62 =  (x^26 + 2*x^24 + x^22 + x^4 - 2*x^2 + 1) / 4
P_k11method62 = x^13 + 2*x^12 + x^11 + x^2 - 2*x + 1 
t_k11method62 = -x^2 + 1
rs.update({"k11method62" :  r_k11method62})
qs.update({"k11method62" :   q_k11method62})
ks.update({"k11method62" :  11})
Ps.update({"k11method62" : P_k11method62})
vs.update({"k11method62" : x^2}) 

# k = 13
# k = 13, D=1, deg(r(x))= 24, rho = 1.25,
# deg(r) = 24, deg(q) = 
r_k13method62 = x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1
q_k13method62 =  (x^30 + 2*x^28 + x^26 + x^4 - 2*x^2 + 1) / 4
P_k13method62 = x^15+2*x^14+x^13+x^2-2*x+1
t_k13method62 = -x^2 + 1
rs.update({"k13method62" :  r_k13method62})
qs.update({"k13method62" :   q_k13method62})
ks.update({"k13method62" :  13})
Ps.update({"k13method62" : P_k13method62})
vs.update({"k13method62" : x^2}) 



# k = 14
# k = 7, D=1, deg(r(x))= 12, rho = 1.8333,
# deg(r) = 12, deg(q) = 22
r_k14method62 = x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1
q_k14method62 = (x^18 + 2*x^16 + x^14 + x^4 - 2*x^2 + 1) / 4
P_k14method62 = x^9 + 2*x^8+x^7+x^2-2*x+1
t_k14method62 = -x^2 + 1
rs.update({"k14method62" :  r_k14method62})
qs.update({"k14method62" :   q_k14method62})
ks.update({"k14method62" :  14})
Ps.update({"k14method62" : P_k14method62})
vs.update({"k14method62" : x^2}) 




# k = 15
# k = 15, D=1, deg(r(x))= 16, rho = 2.12500,
# deg(r) = 16, deg(q) = 34
r_k15method62 = x^16 + x^14 - x^10 - x^8 - x^6 + x^2 + 1
q_k15method62 =  (x^34 + 2*x^32 + x^30 + x^4 - 2*x^2 + 1) / 4
P_k15method62 = x^17 + 2*x^16 + x^15 + x^2 - 2*x + 1
t15method62 = -x^2 + 1
rs.update({"k15method62" :  r_k15method62})
qs.update({"k15method62" :   q_k15method62})
ks.update({"k15method62" :  15})
Ps.update({"k15method62" : P_k15method62})
vs.update({"k15method62" : x^2}) 

# k = 17
# k = 17, D=1, deg(r(x))= 32, rho = 1.187500 ,
# deg(r) = 32, deg(q) = 38
r_k17method62 = x^32 - x^30 + x^28 - x^26 + x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1 
q_k17method62 =  (x^38 + 2*x^36 + x^34 + x^4 - 2*x^2 + 1 ) / 4
P_k17method62 = x^19 + 2*x^18 + x^17 + x^2 - 2*x + 1 
t_k17method62 = -x^2 + 1
rs.update({"k17method62" :  r_k17method62})
qs.update({"k17method62" :   q_k17method62})
ks.update({"k17method62" :  17})
Ps.update({"k17method62" : P_k17method62})
vs.update({"k17method62" : x^2}) 

# k = 18
# k = 9, D=1, deg(r(x))= 12, rho = 1.8333,
# deg(r) = 12, deg(q) = 22

r_k18method62 = x^12 - x^6 +1
q_k18method62 = (x^22 + 2*x^20 + x^18 + x^4 - 2*x^2 + 1 ) / 4
P_k18method62 =  x^11 + 2*x^10 + x^9 + x^2 - 2*x + 1
t18method62 = -x^2 + 1
rs.update({"k18method62" :  r_k18method62})
qs.update({"k18method62" :   q_k18method62})
ks.update({"k18method62" :  18})
Ps.update({"k18method62" : P_k18method62})
vs.update({"k18method62" : x^2}) 

# k = 19
# k = 19, D=1, deg(r(x))= 36, rho = 1.166 ,
# deg(r) = 36, deg(q) = 42
r_k19method62 = x^36 - x^34 + x^32 - x^30 + x^28 - x^26 + x^24 - x^22 + x^20 -x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 +1
q_k19method62 =  (x^42 + 2*x^40 + x^38 + x^4 - 2*x^2 + 1 ) / 4
P_k19method62 = x^21 + 2*x^20 + x^19 + x^2 - 2*x + 1
t_k19method62 = -x^2 + 1
rs.update({"k19method62" :  r_k19method62})
qs.update({"k19method62" :   q_k19method62})
ks.update({"k19method62" :  19})
Ps.update({"k19method62" : P_k19method62})
vs.update({"k19method62" : x^2}) 



# k = 21
# rho = 1.9167
r_k21method62 = x^24 + x^22 - x^18 - x^16 + x^12 - x^8 - x^6 + x^2 + 1
q_k21method62 = (x^46 + 2*x^44 + x^42 + x^4 - 2*x^2 + 1) / 4
P_k21method62 = x^23 + 2*x^22 + x^21 + x^2 - 2*x + 1
rs.update({"k21method62" :  r_k21method62})
qs.update({"k21method62" :   q_k21method62})
ks.update({"k21method62" :  21})
Ps.update({"k21method62" : P_k21method62})
vs.update({"k21method62" : x^2})


# k = 22
# rho = 1.30 
r_k22method62 = x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1             
q_k22method62 = (x^26 + 2*x^24 + x^22 + x^4 - 2*x^2 + 1) / 4
P_k22method62 =  x^13 + 2*x^12 + x^11 + x^2 - 2*x + 1
t_k22method62 = -x^2 + 1
rs.update({"k22method62" :  r_k22method62})
qs.update({"k22method62" :   q_k22method62})
ks.update({"k22method62" :  22})
Ps.update({"k22method62" : P_k22method62})
vs.update({"k22method62" : x^2}) 


# k = 23
# rho = 1.1364 
r_k23method62 = x^44 - x^42 + x^40 - x^38 + x^36 - x^34 + x^32 - x^30 + x^28 - x^26 + x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1
q_k23method62 = (x^50 + 2*x^48 + x^46 + x^4 - 2*x^2 + 1) / 4
P_k23method62 = x^25 + 2*x^24 + x^23 + x^2 - 2*x + 1
rs.update({"k23method62" :  r_k23method62})
qs.update({"k23method62" :   q_k23method62})
ks.update({"k23method62" :  23})
Ps.update({"k23method62" : P_k23method62})
vs.update({"k23method62" : x^2})



# k = 25
# rho = 1.3500 
r_k25method62 = x^40 - x^30 + x^20 - x^10 + 1
q_k25method62 = ( x^54 + 2*x^52 + x^50 + x^4 - 2*x^2 + 1 ) / 4
P_k25method62 = x^27 + 2*x^26 + x^25 + x^2 - 2*x + 1
rs.update({"k25method62" :  r_k25method62})
qs.update({"k25method62" :   q_k25method62})
ks.update({"k25method62" :  25})
Ps.update({"k25method62" : P_k25method62})
vs.update({"k25method62" : x^2})


# k = 26
# rho = 1.25       
r_k26method62 = x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1
q_k26method62 = (x^30 + 2*x^28 + x^26 + x^4 - 2*x^2 + 1) / 4
P_k26method62 = x^15 + 2*x^14 + x^13 + x^4 - 2*x^2 + 1
rs.update({"k26method62" :   r_k26method62})
qs.update({"k26method62" :   q_k26method62})
ks.update({"k26method62" :  26})
Ps.update({"k26method62" : P_k26method62})
vs.update({"k26method62" : x^2})


# k = 27
# rho = 1.6111 
r_k27method62 = x^36 - x^18 + 1
q_k27method62 = ( x^58 + 2*x^56 + x^54 + x^4 - 2*x^2 + 1 ) / 4
P_k27method62 = x^29 + 2*x^28 + x^27 + x^2 - 2*x + 1
rs.update({"k27method62" :  r_k27method62})
qs.update({"k27method62" :   q_k27method62})
ks.update({"k27method62" :  27})
Ps.update({"k27method62" : P_k27method62})
vs.update({"k27method62" : x^2})




# k = 29
# rho = 1.1071   
r_k29method62 = x^56 - x^54 + x^52 - x^50 + x^48 - x^46 + x^44 - x^42 + x^40 - x^38 + x^36 - x^34 + x^32 - x^30 + x^28 - x^26 + x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1
q_k29method62 = ( x^62 + 2*x^60 + x^58 + x^4 - 2*x^2 + 1 ) / 4
P_k29method62 = x^31 + 2*x^30 + x^29 + x^2 - 2*x + 1
rs.update({"k29method62" :  r_k29method62})
qs.update({"k29method62" :   q_k29method62})
ks.update({"k29method62" :  29})
Ps.update({"k29method62" : P_k29method62})
vs.update({"k29method62" : x^2})


# k = 30
# rho = 2.125 
r_k30method62 = x^16 + x^14 - x^10 - x^8 - x^6 + x^2 + 1 
q_k30method62 = (x^34 + 2*x^32 + x^30 + x^4 - 2*x^2 + 1) / 4
P_k30method62 =  x^17 + 2*x^16 + x^15 + x^4 - 2*x^2 + 1
rs.update({"k30method62" :   r_k30method62})
qs.update({"k30method62" :   q_k30method62})
ks.update({"k30method62" :  30})
Ps.update({"k30method62" : P_k30method62})
vs.update({"k30method62" : x^2})


# k = 31
# rho = 1.1000 
r_k31method62 = x^60 - x^58 + x^56 - x^54 + x^52 - x^50 + x^48 - x^46 + x^44 - x^42 + x^40 - x^38 + x^36 - x^34 + x^32 - x^30 + x^28 - x^26 + x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1
q_k31method62 = ( x^66 + 2*x^64 + x^62 + x^4 - 2*x^2 + 1 ) / 4
P_k31method62 = x^33 + 2*x^32 + x^31 + x^2 - 2*x + 1
rs.update({"k31method62" :  r_k31method62})
qs.update({"k31method62" :   q_k31method62})
ks.update({"k31method62" :  31})
Ps.update({"k31method62" : P_k31method62})
vs.update({"k31method62" : x^2})




# k = 33
# rho = 1.7500  
r_k33method62 = x^40 + x^38 - x^34 - x^32 + x^28 + x^26 - x^22 - x^20 - x^18 + x^14 + x^12 - x^8 - x^6 + x^2 + 1
q_k33method62 = ( x^70 + 2*x^68 + x^66 + x^4 - 2*x^2 + 1 ) / 4
P_k33method62 = x^35 + 2*x^34 + x^33 + x^2 - 2*x + 1
rs.update({"k33method62" :  r_k33method62})
qs.update({"k33method62" :   q_k33method62})
ks.update({"k33method62" :  33})
Ps.update({"k33method62" : P_k33method62})
vs.update({"k33method62" : x^2})


# k = 34
# rho = 1.1875      
r_k34method62 = x^32 - x^30 + x^28 - x^26 + x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1                                  
q_k34method62 = (x^38 + 2*x^36 + x^34 + x^4 - 2*x^2 + 1) / 4
P_k34method62 = x^19 + 2*x^18 + x^17 + x^4 - 2*x^2 + 1  
rs.update({"k34method62" :   r_k34method62})
qs.update({"k34method62" :   q_k34method62})
ks.update({"k34method62" :  34})
Ps.update({"k34method62" : P_k34method62})
vs.update({"k34method62" : x^2})


# k = 35
# rho =  
r_k35method62 = x^48 + x^46 - x^38 - x^36 - x^34 - x^32 + x^28 + x^26 + x^24 + x^22 + x^20 - x^16 - x^14 - x^12 - x^10 + x^2 + 1
q_k35method62 = ( x^74 + 2*x^72 + x^70 + x^4 - 2*x^2 + 1 ) / 4
P_k35method62 = x^37 + 2*x^36 + x^35 + x^2 - 2*x + 1
rs.update({"k35method62" :  r_k35method62})
qs.update({"k35method62" :   q_k35method62})
ks.update({"k35method62" :  35})
Ps.update({"k35method62" : P_k35method62})
vs.update({"k35method62" : x^2})



# k = 37
# rho = 1.0833 
r_k37method62 = x^72 - x^70 + x^68 - x^66 + x^64 - x^62 + x^60 - x^58 + x^56 - x^54 + x^52 - x^50 + x^48 - x^46 + x^44 - x^42 + x^40 - x^38 + x^36 - x^34 + x^32 - x^30 + x^28 - x^26 + x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1 
q_k37method62 = ( x^78 + 2*x^76 + x^74 + x^4 - 2*x^2 + 1 ) / 4
P_k37method62 = x^39 + 2*x^38 + x^37 + x^2 - 2*x + 1
rs.update({"k37method62" :  r_k37method62})
qs.update({"k37method62" :   q_k37method62})
ks.update({"k37method62" :  37})
Ps.update({"k37method62" : P_k37method62})
vs.update({"k37method62" : x^2})


# k = 38
# rho = 1.1667             
r_k38method62 = x^36 - x^34 + x^32 - x^30 + x^28 - x^26 + x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1 
q_k38method62 = (x^42 + 2*x^40 + x^38 + x^4 - 2*x^2 + 1) / 4
P_k38method62 =  x^21 + 2*x^20 + x^19 + x^2 - 2*x + 1
rs.update({"k38method62" :   r_k38method62})
qs.update({"k38method62" :   q_k38method62})
ks.update({"k38method62" :  38})
Ps.update({"k38method62" : P_k38method62})
vs.update({"k38method62" : x^2})



# k = 39
# rho = 1.7083 
r_k39method62 = x^48 + x^46 - x^42 - x^40 + x^36 + x^34 - x^30 - x^28 + x^24 - x^20 - x^18 + x^14 + x^12 - x^8 - x^6 + x^2 + 1 
q_k39method62 = ( x^82 + 2*x^80 + x^78 + x^4 - 2*x^2 + 1 ) / 4
P_k39method62 = x^41 + 2*x^40 + x^39 + x^2 - 2*x + 1
rs.update({"k39method62" :  r_k39method62})
qs.update({"k39method62" :   q_k39method62})
ks.update({"k39method62" :  39})
Ps.update({"k39method62" : P_k39method62})
vs.update({"k39method62" : x^2})




# k = 41
# rho = 1.0750 
r_k41method62 = x^80 - x^78 + x^76 - x^74 + x^72 - x^70 + x^68 - x^66 + x^64 - x^62 + x^60 - x^58 + x^56 - x^54 + x^52 - x^50 + x^48 - x^46 + x^44 - x^42 + x^40 - x^38 + x^36 - x^34 + x^32 - x^30 + x^28 - x^26 + x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1 
q_k41method62 = ( x^86 + 2*x^84 + x^82 + x^4 - 2*x^2 + 1 ) / 4
P_k41method62 = x^43 + 2*x^42 + x^41 + x^2 - 2*x + 1
rs.update({"k41method62" :  r_k41method62})
qs.update({"k41method62" :   q_k41method62})
ks.update({"k41method62" :  41})
Ps.update({"k41method62" : P_k41method62})
vs.update({"k41method62" : x^2})


# k = 42
# rho = 1.916            
r_k42method62 = x^24 + x^22 - x^18 - x^16 + x^12 - x^8 - x^6 + x^2 + 1 
q_k42method62 = (x^46 + 2*x^44 + x^42 + x^4 - 2*x^2 + 1) / 4
P_k42method62 = x^23 + 2*x^22 + x^21 + x^2 - 2*x + 1
rs.update({"k42method62" :   r_k42method62})
qs.update({"k42method62" :   q_k42method62})
ks.update({"k42method62" :  42})
Ps.update({"k42method62" : P_k42method62})
vs.update({"k42method62" : x^2})


# k = 43
# rho =        
r_k43method62 = x^84 - x^82 + x^80 - x^78 + x^76 - x^74 + x^72 - x^70 + x^68 - x^66 + x^64 - x^62 + x^60 - x^58 + x^56 - x^54 + x^52 - x^50 + x^48 - x^46 + x^44 - x^42 + x^40 - x^38 + x^36 - x^34 + x^32 - x^30 + x^28 - x^26 + x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1 
q_k43method62 = ( x^90 + 2*x^88 + x^86 + x^4 - 2*x^2 + 1 ) / 4
P_k43method62 = x^45 + 2*x^44 + x^43 + x^2 - 2*x + 1
rs.update({"k43method62" :  r_k43method62})
qs.update({"k43method62" :   q_k43method62})
ks.update({"k43method62" :  43})
Ps.update({"k43method62" : P_k43method62})
vs.update({"k43method62" : x^2})




# k = 45
# rho = 1.9583       
r_k45method62 = x^48 + x^42 - x^30 - x^24 - x^18 + x^6 + 1 
q_k45method62 = ( x^94 + 2*x^92 + x^90 + x^4 - 2*x^2 + 1 ) / 4
P_k45method62 = x^47 + 2*x^46 + x^45 + x^2 - 2*x + 1
rs.update({"k45method62" :  r_k45method62})
qs.update({"k45method62" :   q_k45method62})
ks.update({"k45method62" :  45})
Ps.update({"k45method62" : P_k45method62})
vs.update({"k45method62" : x^2})


# k = 46
# rho = 1.136                 
r_k46method62 = x^44 - x^42 + x^40 - x^38 + x^36 - x^34 + x^32 - x^30 + x^28 - x^26 + x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1                                                       
q_k46method62 = (x^50 + 2*x^48 + x^46 + x^4 - 2*x^2 + 1) / 4
P_k46method62 = x^25 + 2*x^24 + x^23 + x^2 - 2*x + 1
rs.update({"k46method62" :   r_k46method62})
qs.update({"k46method62" :   q_k46method62})
ks.update({"k46method62" :  46})
Ps.update({"k46method62" : P_k46method62})
vs.update({"k46method62" : x^2})



# k = 47
# rho = 1.0652        
r_k47method62 = x^92 - x^90 + x^88 - x^86 + x^84 - x^82 + x^80 - x^78 + x^76 - x^74 + x^72 - x^70 + x^68 - x^66 + x^64 - x^62 + x^60 - x^58 + x^56 - x^54 + x^52 - x^50 + x^48 - x^46 + x^44 - x^42 + x^40 - x^38 + x^36 - x^34 + x^32 - x^30 + x^28 - x^26 + x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1 
q_k47method62 = ( x^98 + 2*x^96 + x^94 + x^4 - 2*x^2 + 1 ) / 4
P_k47method62 = x^49 + 2*x^48 + x^47 + x^2 - 2*x + 1
rs.update({"k47method62" :  r_k47method62})
qs.update({"k47method62" :   q_k47method62})
ks.update({"k47method62" :  47})
Ps.update({"k47method62" : P_k47method62})
vs.update({"k47method62" : x^2})




# k = 49
# rho = 1.2143       
r_k49method62 = x^84 - x^70 + x^56 - x^42 + x^28 - x^14 + 1
q_k49method62 = ( x^102 + 2*x^100 + x^98 + x^4 - 2*x^2 + 1 ) / 4
P_k49method62 = x^51 + 2*x^50 + x^49 + x^2 - 2*x + 1
rs.update({"k49method62" :  r_k49method62})
qs.update({"k49method62" :   q_k49method62})
ks.update({"k49method62" :  49})
Ps.update({"k49method62" : P_k49method62})
vs.update({"k49method62" : x^2})


# k = 50
# rho = 1.350                      
r_k50method62 = x^40 - x^30 + x^20 - x^10 + 1 
q_k50method62 = (x^54 + 2*x^52 + x^50 + x^4 - 2*x^2 + 1) / 4
P_k50method62 =  x^27 + 2*x^26 + x^25 + x^2 - 2*x + 1
rs.update({"k50method62" :   r_k50method62})
qs.update({"k50method62" :   q_k50method62})
ks.update({"k50method62" :  50})
Ps.update({"k50method62" : P_k50method62})
vs.update({"k50method62" : x^2})


# k = 51
# rho = 1.2619       
r_k51method62 = x^64 + x^62 - x^58 - x^56 + x^52 + x^50 - x^46 - x^44 + x^40 + x^38 - x^34 - x^32 - x^30 + x^26 + x^24 - x^20 - x^18 + x^14 + x^12 - x^8 - x^6 + x^2 + 1
q_k51method62 = ( x^106 + 2*x^104 + x^102 + x^4 - 2*x^2 + 1 ) / 4
P_k51method62 = x^53 + 2*x^52 + x^51 + x^2 - 2*x + 1
rs.update({"k51method62" :  r_k51method62})
qs.update({"k51method62" :   q_k51method62})
ks.update({"k51method62" :  51})
Ps.update({"k51method62" : P_k51method62})
vs.update({"k51method62" : x^2})



# k = 53
# rho = 1.0577 
r_k53method62 = x^104 - x^102 + x^100 - x^98 + x^96 - x^94 + x^92 - x^90 + x^88 - x^86 + x^84 - x^82 + x^80 - x^78 + x^76 - x^74 + x^72 - x^70 + x^68 - x^66 + x^64 - x^62 + x^60 - x^58 + x^56 - x^54 + x^52 - x^50 + x^48 - x^46 + x^44 - x^42 + x^40 - x^38 + x^36 - x^34 + x^32 - x^30 + x^28 - x^26 + x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1 
q_k53method62 = ( x^110 + 2*x^108 + x^106 + x^4 - 2*x^2 + 1 ) / 4
P_k53method62 = x^55 + 2*x^54 + x^53 + x^2 - 2*x + 1
rs.update({"k53method62" :  r_k53method62})
qs.update({"k53method62" :   q_k53method62})
ks.update({"k53method62" :  53})
Ps.update({"k53method62" : P_k53method62})
vs.update({"k53method62" : x^2})


# k = 54
# rho = 1.611                           
r_k54method62 = x^36 - x^18 + 1                              
q_k54method62 = (x^58 + 2*x^56 + x^54 + x^4 - 2*x^2 + 1) / 4
P_k54method62 =  x^29 + 2*x^28 + x^27 + x^2 - 2*x + 1
rs.update({"k54method62" :   r_k54method62})
qs.update({"k54method62" :   q_k54method62})
ks.update({"k54method62" :  54})
Ps.update({"k54method62" : P_k54method62})
vs.update({"k54method62" : x^2})

#-----------------------------------------------------------------------------



#---------------------------- method 6.3--------------------------------------
# k = odd, D=1, k_prime = 2*k , rho = (k+2)/phi(k_prime), 
#r(x) = CyclotomicPolynomial(4*k)
#q(x) = (x^(2*k+4) - 2*x^(2*k+2) + x^(2*k) + x^4 + 2*x^2 + 1) / 4
#t(x) = x^2 + 1
# we can construct k = 14 (2x7),18 (2x9)
#Q = RationalField()
#P<x> = PolynomialRing(Q)
#k =7
#k_prime = 2*k
#(k+2.)/EulerPhi(k_prime)
#CyclotomicPolynomial(4*k)
#q = (x^(2*k+4) - 2*x^(2*k+2) + x^(2*k) + x^4 + 2*x^2 + 1) / 4
#q
#Degree(q)


# k = 5
# k_prime = 10, D=1, deg(r(x))= 8, rho = 1.75 ,
# deg(r) = 12, deg(q) = 18
r_k10method63 = x^8 - x^6 + x^4 - x^2 + 1                                       
q_k10method63 =  ( x^14 - 2*x^12 + x^10 + x^4 + 2*x^2 + 1 ) / 4
P_k10method63 = x^7-2*x^6+x^5+x^2+2*x+1
t_k10method63 = -x^2 + 1
rs.update({"k10method63" :  r_k10method63})
qs.update({"k10method63" :   q_k10method63})
ks.update({"k10method63" :  10})
Ps.update({"k10method63" : P_k10method63})
vs.update({"k10method63" : x^2}) 



# k = 7
# k_prime = 14, D=1, deg(r(x))= 12, rho = 1.50 ,
# deg(r) = 12, deg(q) = 18
r_k14method63 = x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1
q_k14method63 =  (x^18 - 2*x^16 + x^14 + x^4 + 2*x^2 + 1 ) / 4
P_k14method63 = x^9-2*x^8+x^7+x^2+2*x+1
t_k14method63 = -x^2 + 1
rs.update({"k14method63" :  r_k14method63})
qs.update({"k14method63" :   q_k14method63})
ks.update({"k14method63" :  14})
Ps.update({"k14method63" : P_k14method63})
vs.update({"k14method63" : x^2}) 

# k = 9
# k_prime = 18, D=1, deg(r(x))= 12, rho = 1.833 ,
# deg(r) = 12, deg(q) = 22
r_k18method63 = x^12 - x^6 + 1
q_k18method63 =  (x^22 - 2*x^20 + x^18 + x^4 + 2*x^2 + 1) / 4
P_k18method63 = x^11 - 2*x^10 + x^9 + x^2 + 2*x + 1
t_k18method63 = -x^2 + 1
rs.update({"k18method63" :  r_k18method63})
qs.update({"k18method63" :   q_k18method63})
ks.update({"k18method63" :  18})
Ps.update({"k18method63" : P_k18method63})
vs.update({"k18method63" : x^2}) 

# k = 11
# k_prime = 22, D=1, deg(r(x))= 20, rho = 1.3 
k=11
r_k22method63 = x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1 
q_k22method63 = (x^26 - 2*x^24 + x^22 + x^4 + 2*x^2 + 1) / 4
P_k22method63 = x^13 - 2*x^12 + x^11 + x^2 - x + 1
t_k22method63 = -x^2 + 1
rs.update({"k22method63" :  r_k22method63})
qs.update({"k22method63" :   q_k22method63})
ks.update({"k22method63" :  22})
Ps.update({"k22method63" : P_k22method63})
vs.update({"k22method63" : x^2}) 

# k = 13
# k_prime = 26, D=1, deg(r(x))= 24, rho = 1.25 
k=13
r_k26method63 = x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1 
q_k26method63 = (x^30 - 2*x^28 + x^26 + x^4 + 2*x^2 + 1) / 4 
P_k26method63 = x^15 - 2*x^14 + x^13 + x^2 + 2*x + 1
t_k26method63 = -x^2 + 1
rs.update({"k26method63" :  r_k26method63})
qs.update({"k26method63" :   q_k26method63})
ks.update({"k26method63" :  26})
Ps.update({"k26method63" : P_k26method63})
vs.update({"k26method63" : x^2}) 


# k = 15
# k_prime = 30, D=1, deg(r(x))= 16, rho = 2.125 
r_k30method63 = x^16 + x^14 - x^10 - x^8 - x^6 + x^2 + 1  
q_k30method63 = ( x^34 - 2*x^32 + x^30 + x^4 + 2*x^2 + 1 ) / 4 
P_k30method63 = x^17 - 2*x^16 + x^15 + x^2 + 2*x + 1
t_k30method63 = -x^2 + 1
rs.update({"k30method63" :  r_k30method63})
qs.update({"k30method63" :   q_k30method63})
ks.update({"k30method63" :  30})
Ps.update({"k30method63" : P_k30method63})
vs.update({"k30method63" : x^2}) 


# k = 17
# k_prime = 30, D=1, deg(r(x))= 32, rho = 1.1875 
r_k34method63 = x^32 - x^30 + x^28 - x^26 + x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1
q_k34method63 = x^38 - 2*x^36 + x^34 + x^4 + 2*x^2 + 1
P_k34method63 = x^19 - 2*x^18 + x^17 + x^2 + 2*x + 1
t_k34method63 = -x^2 + 1
rs.update({"k34method63" :  r_k34method63})
qs.update({"k34method63" :   q_k34method63})
ks.update({"k34method63" :  34})
Ps.update({"k34method63" : P_k34method63})
vs.update({"k34method63" : x^2}) 



# k = 19
# k_prime = 38, D=1, deg(r(x))= 24, rho = 1.167 
r_k38method63 = x^36 - x^34 + x^32 - x^30 + x^28 - x^26 + x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1 
q_k38method63 = x^42 - 2*x^40 + x^38 + x^4 + 2*x^2 + 1     
P_k38method63 = x^21 - 2*x^20 + x^19 + x^2 + 2*x + 1  
t_k38method63 = -x^2 + 1
rs.update({"k38method63" :  r_k38method63})
qs.update({"k38method63" :   q_k38method63})
ks.update({"k38method63" :  38})
Ps.update({"k38method63" : P_k38method63})
vs.update({"k38method63" : x^2}) 


# k = 21
# k_prime = 42, D=1, deg(r(x))= 24, rho = 1.9167 
r_k42method63 = x^24 + x^22 - x^18 - x^16 + x^12 - x^8 - x^6 + x^2 + 1
q_k42method63 = x^46 - 2*x^44 + x^42 + x^4 + 2*x^2 + 1
P_k42method63 = x^23 - 2*x^22 + x^21 + x^2 + 2*x + 1
t_k42method63 = -x^2 + 1
rs.update({"k42method63" :  r_k42method63})
qs.update({"k42method63" :   q_k42method63})
ks.update({"k42method63" :  42})
Ps.update({"k42method63" : P_k42method63})
vs.update({"k42method63" : x^2}) 


# k = 23
# k_prime = 46, D=1, deg(r(x))= 44, rho = 1.1363 
r_k46method63 = x^44 - x^42 + x^40 - x^38 + x^36 - x^34 + x^32 - x^30 + x^28 - x^26 + x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1
q_k46method63 = x^50 - 2*x^48 + x^46 + x^4 + 2*x^2 + 1
P_k46method63 = x^25 - 2*x^24 + x^23 + x^2 + 2*x + 1
t_k46method63 = -x^2 + 1
rs.update({"k46method63" :  r_k46method63})
qs.update({"k46method63" :   q_k46method63})
ks.update({"k46method63" :  46})
Ps.update({"k46method63" : P_k46method63})
vs.update({"k46method63" : x^2}) 



# k = 25
# k_prime = 50, D=1, deg(r(x))= 40, rho = 1.35 
r_k50method63 = x^40 - x^30 + x^20 - x^10 + 1
q_k50method63 = x^54 - 2*x^52 + x^50 + x^4 + 2*x^2 + 1 
P_k50method63 = x^27 - 2*x^26 + x^25 + x^2 + 2*x + 1
t_k50method63 = -x^2 + 1
rs.update({"k50method63" :  r_k50method63})
qs.update({"k50method63" :   q_k50method63})
ks.update({"k50method63" :  50})
Ps.update({"k50method63" : P_k50method63})
vs.update({"k50method63" : x^2}) 


# k = 27
# k_prime = 54, D=1, deg(r(x))= 36, rho = 1.61 
r_k54method63 = x^36 - x^18 + 1                             
q_k54method63 = x^58 - 2*x^56 + x^54 + x^4 + 2*x^2 + 1  
P_k54method63 = x^29 - 2*x^28 + x^27 + x^2 + 2*x + 1
t_k54method63 = -x^2 + 1
rs.update({"k54method63" :  r_k54method63})
qs.update({"k54method63" :   q_k54method63})
ks.update({"k54method63" :  54})
Ps.update({"k54method63" : P_k54method63})
vs.update({"k54method63" : x^2}) 



#-----------------------------------------------------------------------------



#---------------------------- method 6.4--------------------------------------
# k odd, D = 1
#Q = RationalField()
#P<x> = PolynomialRing(Q)
#k =4
#k_prime = 4*k
#(k_prime/2+2.)/EulerPhi(k_prime) family indexed over k_prime
#CyclotomicPolynomial(4*k)
#q = (x^(2*k+2) - 2*x^(2*k + 1) + x^(2*k) + x^2 + 2*x + 1) / 4
#q
#Degree(q)

# k=3
r_k12method64= x^4 - x^2 + 1 #r = CyclotomicPolynomial(4*k)
q_k12method64 = (x^8 - 2*x^7 + x^6 + x^2 + 2*x + 1 ) / 4 
P_k12method64 = x^4 - 2*x^3 + 5*x^2 - 6*x + 4  
t_k12method64 = x+1
rs.update({"k12method64" :  r_k12method64})
qs.update({"k12method64" :  q_k12method64})
ks.update({"k12method64" :  12})
Ps.update({"k12method64" : P_k12method64})
vs.update({"k12method64" : x-1/x}) 

######/ #k =20

#k =5 
#kPrime = 4*k # this is the embedding degree
#rho = 1.5
r_k20method64=x^8 - x^6 + x^4 - x^2 + 1
q_k20method64= (x^12 - 2*x^11 + x^10 + x^2 + 2*x + 1)/ 4
P_k20method64 = x^6 - 2*x^5 + 7*x^4 - 10*x^3 + 13*x^2 - 10*x + 4  
t_k20method64 = x+1
rs.update({"k20method64" :  r_k20method64})
qs.update({"k20method64" :  q_k20method64})
ks.update({"k20method64" :  20})
Ps.update({"k20method64" : P_k20method64})
vs.update({"k20method64" : x-1/x}) 



### #k = 28
#k =7
#kPrime = 4*7
#rho = 1.33
r_k28method64=x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1
q_k28method64= (x^16 - 2*x^15 + x^14 + x^2 + 2*x + 1)/ 4
P_k28method64 = x^8 - 2*x^7 + 9*x^6 - 14*x^5 + 26*x^4 - 28*x^3 + 25*x^2 - 14*x + 4                                                  
t_k28method64 = x+1
rs.update({"k28method64" :  r_k28method64})
qs.update({"k28method64" :  q_k28method64})
ks.update({"k28method64" :  28})
Ps.update({"k28method64" : P_k28method64})
vs.update({"k28method64" : x-1/x}) 

### #k = 36
#k =9
#kPrime = 4*9
#rho = 1.667
r_k36method64=x^12 - x^6 + 1
q_k36method64= (x^20 - 2*x^19 + x^18 + x^2 + 2*x + 1)/ 4
P_k36method64 = x^10 - 2*x^9 + 11*x^8 - 18*x^7 + 43*x^6 - 54*x^5 + 70*x^4 - 60*x^3 + 41*x^2 - 18*x + 4                                           
t_k36method64 = x+1
rs.update({"k36method64" :  r_k36method64})
qs.update({"k36method64" :  q_k36method64})
ks.update({"k36method64" :  36})
Ps.update({"k36method64" : P_k36method64})
vs.update({"k36method64" : x-1/x}) 

## #k = 44
#k = 11
#kPrime = 4*11
#rho =1.20
r_k44method64 = x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1
q_k44method64 = (x^24 - 2*x^23 + x^22 + x^2 + 2*x + 1)/ 4
P_k44method64 = x^10 - 2*x^9 + 11*x^8 - 18*x^7 + 43*x^6 - 54*x^5 + 70*x^4 - 60*x^3 + 41*x^2 - 18*x + 4                                           
t_k44method64 = x+1
rs.update({"k44method64" :  r_k44method64})
qs.update({"k44method64" :  q_k44method64})
ks.update({"k44method64" :  44})
Ps.update({"k44method64" : P_k44method64})
vs.update({"k44method64" : x-1/x}) 

## #k = 52
#k = 13
#kPrime = 4*13
#rho =1.1667
r_k52method64 = x^24 - x^22 + x^20 - x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1
q_k52method64 = (x^28 - 2*x^27 + x^26 + x^2 + 2*x + 1)/ 4
P_k52method64 = x^14 - 2*x^13 + 15*x^12 - 26*x^11 + 89*x^10 - 130*x^9 + 264*x^8 - 312*x^7 + 406*x^6 - 364*x^5 + 301*x^4 - 182*x^3 + 85*x^2 - 26*x + 4  
t_k52method64 = x+1
rs.update({"k52method64" :  r_k52method64})
qs.update({"k52method64" :  q_k52method64})
ks.update({"k52method64" :  52})
Ps.update({"k52method64" : P_k52method64})
vs.update({"k52method64" : x-1/x}) 


#-----------------------------------------------------------------------------



#----------------------------------- method 6.6  BLS --------------------------
#k >0, k neq 0 mod 18
# D = 3
#Q = RationalField()
#P<x> = PolynomialRing(Q)
# the construction is different following the value of k mod 6
#l = Lcm(6,k)
# rho = (l/3 +6)/EulerPhi(l) #if k = 4 mod 6
# rho = (l/3 +2)/EulerPhi(l) #else

# k = 0 mod 6, k = 12 in our parameters
#n=12, D= 3, 
# k= 12
# l =lcm(6,k)= 12
# rho = (l/3+2)/phi(l) = (4+2)/4 = 1.5 
# deg(q) = 6
#deg(r) = 4

r_k12method66 = x^4 - x^2 + 1 #r = CyclotomicPolynomial(k)
q_k12method66 = ((((x-1)^2)*(x^4 - x^2 +1) ) / 3) + x 
P_k12method66 = q_k12method66.numerator()
t_k12method66 = x+1
rs.update({"k12method66" :  r_k12method66})
qs.update({"k12method66" :  q_k12method66})
ks.update({"k12method66" :  12})
Ps.update({"k12method66" : P_k12method66})
vs.update({"k12method66" : x})


k = 18  # rho=1.33 
r_k18method66 = x^6 - x^3 + 1
q_k18method66 = (x^8 - 2*x^7 + x^6 - x^5 + 2*x^4 - x^3 + x^2 + x + 1)/3
P_k18method66 = 3*q_k18method66
rs.update({"k18method66" :  r_k18method66})
qs.update({"k18method66" :  q_k18method66})
ks.update({"k18method66" :  18})
Ps.update({"k18method66" : P_k18method66})
vs.update({"k18method66" : x})

k = 24 # rho=1.25 
r_k24method66 = x^8 - x^4 + 1
q_k24method66 = (x^10 - 2*x^9 + x^8 - x^6 + 2*x^5 - x^4 + x^2 + x + 1)/3
P_k24method66 = 3*q_k24method66
rs.update({"k24method66" :  r_k24method66})
qs.update({"k24method66" :  q_k24method66})
ks.update({"k24method66" :  24})
Ps.update({"k24method66" : P_k24method66})
vs.update({"k24method66" : x})


k = 30 # rho=1.5
r_k30method66 = x^8 + x^7 - x^5 - x^4 - x^3 + x + 1
q_k30method66 = (x^12 - 2*x^11 + x^10 - x^7 + 2*x^6 - x^5 + x^2 + x + 1)/3
P_k30method66 = 3*q_k30method66
rs.update({"k30method66" :  r_k30method66})
qs.update({"k30method66" :  q_k30method66})
ks.update({"k30method66" :  30})
Ps.update({"k30method66" : P_k30method66})
vs.update({"k30method66" : x})


k = 36  # rho= 1.1667
r_k36method66 = x^12 - x^6 + 1
q_k36method66 = (x^14 - 2*x^13 + x^12 - x^8 + 2*x^7 - x^6 + x^2 + x + 1)/3
P_k36method66 = 3*q_k36method66
rs.update({"k36method66" :  r_k36method66})
qs.update({"k36method66" :  q_k36method66})
ks.update({"k36method66" :  36})
Ps.update({"k36method66" : P_k36method66})
vs.update({"k36method66" : x})

k = 42 # rho= 1.33
r_k42method66 = x^12 + x^11 - x^9 - x^8 + x^6 - x^4 - x^3 + x + 1
q_k42method66 = (x^16 - 2*x^15 + x^14 - x^9 + 2*x^8 - x^7 + x^2 + x + 1)/3
P_k42method66 = 3*q_k42method66
rs.update({"k42method66" :  r_k42method66})
qs.update({"k42method66" :  q_k42method66})
ks.update({"k42method66" :  42})
Ps.update({"k42method66" : P_k42method66})
vs.update({"k42method66" : x})


k = 48 # rho = 1.125
r_k48method66 =  x^16 - x^8 + 1                                                
q_k48method66 = (x^18 - 2*x^17 + x^16 - x^10 + 2*x^9 - x^8 + x^2 + x + 1)/3
P_k48method66 = 3*q_k48method66
rs.update({"k48method66" :  r_k48method66})
qs.update({"k48method66" :  q_k48method66})
ks.update({"k48method66" :  48})
Ps.update({"k48method66" : P_k48method66})
vs.update({"k48method66" : x})


k = 54 # rho= 1.111
r_k54method66 = x^18 - x^9 + 1 
q_k54method66 = (x^20 - 2*x^19 + x^18 - x^11 + 2*x^10 - x^9 + x^2 + x + 1)/3
P_k54method66 = 3*q_k54method66
rs.update({"k54method66" :  r_k54method66})
qs.update({"k54method66" :  q_k54method66})
ks.update({"k54method66" :  54})
Ps.update({"k54method66" : P_k54method66})
vs.update({"k54method66" : x})



# k = 1 mod 6, k = 13, 19 in our parameters
#r = CyclotomicPolynomial(6*k)
# t = -x^(k+1) + x + 1
# q = (( x + 1 )^2)*(x^(2*k) - x^k + 1) / 3 - x^(2*k+1)

#k13method66= 13 # deg(r) = 24, deg(q) = 28 
rho = 1,166
r_k13method66 = x^24 + x^23 - x^21 - x^20 + x^18 + x^17 - x^15 - x^14 + x^12 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
t_k13method66 = -x^14 + x + 1
q_k13method66 = (x^28 - x^27 + x^26 - x^15 - 2*x^14 - x^13 + x^2 + 2*x + 1)  / 3
P_k13method66 = 3*q_k13method66  # there is a quadratic subfield ut k is prime
rs.update({"k13method66" :  r_k13method66})
qs.update({"k13method66" :  q_k13method66})
ks.update({"k13method66" :  13})
Ps.update({"k13method66" : P_k13method66})
vs.update({"k13method66" : x})


k= 19 # deg(r) = 36, deg(q) = 40 
rho = 1,111
r_k19method66 = x^36 + x^35 - x^33 - x^32 + x^30 + x^29 - x^27 - x^26 + x^24 + x^23 - x^21 - x^20 + x^18 - x^16 - x^15 + x^13 + x^12 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
t_k19method66 = -x^20 + x + 1
q_k19method66 = (x^40 - x^39 +  x^38 -  x^21 - 2*x^20 -  x^19 +  x^2 + 2*x + 1)  / 3
P_k19method66 = 3*q_k19method66
rs.update({"k19method66" :  r_k19method66})
qs.update({"k19method66" :  q_k19method66})
ks.update({"k19method66" :  19})
Ps.update({"k19method66" : P_k19method66})
vs.update({"k19method66" : x})


k = 25  # rho= 1.3
r_k25method66 = x^40 + x^35 - x^25 - x^20 - x^15 + x^5 + 1
q_k25method66 = (x^52 - x^51 + x^50 - x^27 - 2*x^26 - x^25 + x^2 + 2*x + 1) / 3
P_k25method66 = 3 * q_k25method66
rs.update({"k25method66" :  r_k25method66})
qs.update({"k25method66" :  q_k25method66})
ks.update({"k25method66" :  25})
Ps.update({"k25method66" : P_k25method66})
vs.update({"k25method66" : x})


k = 31 # rho= 1.0667
r_k31method66 = x^60 + x^59 - x^57 - x^56 + x^54 + x^53 - x^51 - x^50 + x^48 + x^47 - x^45 - x^44 + x^42 + x^41 - x^39 - x^38 + x^36 + x^35 - x^33 - x^32 + x^30 - x^28 - x^27 + x^25 + x^24 - x^22 - x^21 + x^19 + x^18 - x^16 - x^15 + x^13 + x^12 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
q_k31method66 = (x^64 - x^63 + x^62 - x^33 - 2*x^32 - x^31 + x^2 + 2*x + 1)/3
P_k31method66 = 3*q_k31method66
rs.update({"k31method66" :  r_k31method66})
qs.update({"k31method66" :  q_k31method66})
ks.update({"k31method66" :  31})
Ps.update({"k31method66" : P_k31method66})
vs.update({"k31method66" : x})


k = 37 # rho=1.0556 
r_k37method66 = x^72 + x^71 - x^69 - x^68 + x^66 + x^65 - x^63 - x^62 + x^60 + x^59 - x^57 - x^56 + x^54 + x^53 - x^51 - x^50 + x^48 + x^47 - x^45 - x^44 + x^42 + x^41 - x^39 - x^38 + x^36 - x^34 - x^33 + x^31 + x^30 - x^28 - x^27 + x^25 + x^24 - x^22 - x^21 + x^19 + x^18 - x^16 - x^15 + x^13 + x^12 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
q_k37method66 = (x^76 - x^75 + x^74 - x^39 - 2*x^38 - x^37 + x^2 + 2*x + 1)/3
P_k37method66 = 3*q_k37method66
rs.update({"k37method66" :  r_k37method66})
qs.update({"k37method66" :  q_k37method66})
ks.update({"k37method66" :  37})
Ps.update({"k37method66" : P_k37method66})
vs.update({"k37method66" : x})



k = 43 # rho=1.0476 
r_k43method66 = x^84 + x^83 - x^81 - x^80 + x^78 + x^77 - x^75 - x^74 + x^72 + x^71 - x^69 - x^68 + x^66 + x^65 - x^63 - x^62 + x^60 + x^59 - x^57 - x^56 + x^54 + x^53 - x^51 - x^50 + x^48 + x^47 - x^45 - x^44 + x^42 - x^40 - x^39 + x^37 + x^36 - x^34 - x^33 + x^31 + x^30 - x^28 - x^27 + x^25 + x^24 - x^22 - x^21 + x^19 + x^18 - x^16 - x^15 + x^13 + x^12 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
q_k43method66 = (x^88 - x^87 + x^86 - x^45 - 2*x^44 - x^43 + x^2 + 2*x + 1)/3
P_k43method66 = 3*q_k43method66
rs.update({"k43method66" :  r_k43method66})
qs.update({"k43method66" :  q_k43method66})
ks.update({"k43method66" :  43})
Ps.update({"k43method66" : P_k43method66})
vs.update({"k43method66" : x})


k = 49 # 1.1905 
r_k49method66 = x^84 + x^77 - x^63 - x^56 + x^42 - x^28 - x^21 + x^7 + 1
q_k49method66 = x^100 - x^99 + x^98 - x^51 - 2*x^50 - x^49 + x^2 + 2*x + 1 
P_k49method66 = 3*q_k49method66
rs.update({"k49method66" :  r_k49method66})
qs.update({"k49method66" :  q_k49method66})
ks.update({"k49method66" :  49})
Ps.update({"k49method66" : P_k49method66})
vs.update({"k49method66" : x})




# k = 2 mod 6, k = 14, 20 in our parameters
#r = CyclotomicPolynomial(3*k)
# t = x^((k / 2) +1) - x +1
# q = ((x-1)^2)*(x^k - x^(k / 2) + 1) / 3 + x^(k+1)

k= 14 # deg(r) = 12, deg(q) = 16 
rho = 1,333
r_14method66 =  x^12 +  x^11 -  x^9 - x^8 +  x^6 -  x^4 -  x^3 +  x + 1
t_14method66 = x^8 - x + 1
q_14method66 = (x^16 + x^15 + x^14 - x^9 + 2*x^8 - x^7 + x^2 - 2*x +1)  / 3
P_k14method66 = 3*q_14method66
rs.update({"k14method66" :  r_14method66})
qs.update({"k14method66" :  q_14method66})
ks.update({"k14method66" :  14})
Ps.update({"k14method66" : P_k14method66})
vs.update({"k14method66" : x})

k= 20 # deg(r) = 16, deg(q) = 22 
rho = 1,375
r_20method66 = x^16 + x^14 - x^10 - x^8 - x^6 + x^2 + 1
t_20method66 = x^11 - x + 1
q_20method66 = (x^22 +x^21 +x^20 -x^12 + 2*x^11 - x^10 + x^2 - 2*x + 1)  / 3
P_k20method66 = 3*q_20method66
rs.update({"k20method66" :  r_20method66})
qs.update({"k20method66" :  q_20method66})
ks.update({"k20method66" :  20})
Ps.update({"k20method66" : P_k20method66})
vs.update({"k20method66" : x})


k = 26  # rho = 1.1667
r_k26method66 = x^24 + x^23 - x^21 - x^20 + x^18 + x^17 - x^15 - x^14 + x^12 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
q_k26method66 = (x^28 + x^27 + x^26 - x^15 + 2*x^14 - x^13 + x^2 - 2*x + 1)/3
P_k26method66 = 3*q_k26method66
rs.update({"k26method66" :  r_k26method66})
qs.update({"k26method66" :  q_k26method66})
ks.update({"k26method66" :  26})
Ps.update({"k26method66" : P_k26method66})
vs.update({"k26method66" : x})


k = 32   # rho = 1.0625 
r_k32method66 = x^32 - x^16 + 1
q_k32method66 = (x^34 + x^33 + x^32 - x^18 + 2*x^17 - x^16 + x^2 - 2*x + 1)/3
P_k32method66 = 3*q_k32method66
rs.update({"k32method66" :  r_k32method66})
qs.update({"k32method66" :  q_k32method66})
ks.update({"k32method66" :  32})
Ps.update({"k32method66" : P_k32method66})
vs.update({"k32method66" : x})


k = 38  # rho = 1.1111 
r_k38method66 = x^36 + x^35 - x^33 - x^32 + x^30 + x^29 - x^27 - x^26 + x^24 + x^23 - x^21 - x^20 + x^18 - x^16 - x^15 + x^13 + x^12 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
q_k38method66 = (x^40 + x^39 + x^38 - x^21 + 2*x^20 - x^19 + x^2 - 2*x + 1)/3
P_k38method66 = 3*q_k38method66
rs.update({"k38method66" :  r_k38method66})
qs.update({"k38method66" :  q_k38method66})
ks.update({"k38method66" :  38})
Ps.update({"k38method66" : P_k38method66})
vs.update({"k38method66" : x})


k = 44 # rho = 1.15 
r_k44method66 = x^40 + x^38 - x^34 - x^32 + x^28 + x^26 - x^22 - x^20 - x^18 + x^14 + x^12 - x^8 - x^6 + x^2 + 1
q_k44method66 = x^46 + x^45 + x^44 - x^24 + 2*x^23 - x^22 + x^2 - 2*x + 1
P_k44method66 = 3*q_k44method66
rs.update({"k44method66" :  r_k44method66})
qs.update({"k44method66" :  q_k44method66})
ks.update({"k44method66" :  44})
Ps.update({"k44method66" : P_k44method66})
vs.update({"k44method66" : x})


k = 50 # rho = 1.3
r_k50method66 = x^40 + x^35 - x^25 - x^20 - x^15 + x^5 + 1
q_k50method66 = (x^52 + x^51 + x^50 - x^27 + 2*x^26 - x^25 + x^2 - 2*x + 1)/3
P_k50method66 = 3*q_k50method66
rs.update({"k50method66" :  r_k50method66})
qs.update({"k50method66" :  q_k50method66})
ks.update({"k50method66" :  50})
Ps.update({"k50method66" : P_k50method66})
vs.update({"k50method66" : x})


# k = 3 mod 6, k = 15 in our parameters
#r = CyclotomicPolynomial(2*k)
# t = -x^((k / 3) +1) + x + 1
# q = (( x + 1 )^2)*(x^(2*(k / 3)) - x^(k / 3) + 1) / 3 - x^(2*(k / 3) +1)


k = 9 
r_k9method66 = x^6 - x^3 + 1
q_k9method66 = (x^8 - x^7 + x^6 - x^5 - 2*x^4 - x^3 + x^2 + 2*x + 1)  / 3
P_k9method66 = q_k9method66.numerator()
rs.update({"k9method66" :  r_k9method66})
qs.update({"k9method66" :  q_k9method66})
ks.update({"k9method66" :  9})
Ps.update({"k9method66" : P_k9method66})
vs.update({"k9method66" : x})

k= 15 # deg(r) = 8, deg(q) = 12 
rho = 1,50
r_k15method66 = x^8 + x^7 - x^5 - x^4 - x^3 + x + 1
t_k15method66 = -x^6 + x + 1
q_k15method66 = (x^12 - x^11 + x^10 - x^7 - 2*x^6 - x^5 + x^2 + 2*x + 1)  / 3
P_k15method66 = 3*q_k15method66
rs.update({"k15method66" :  r_k15method66})
qs.update({"k15method66" :  q_k15method66})
ks.update({"k15method66" :  15})
Ps.update({"k15method66" : P_k15method66})
vs.update({"k15method66" : x})


k = 21 # rho=1.33 
r_k21method66 = x^12 + x^11 - x^9 - x^8 + x^6 - x^4 - x^3 + x + 1
q_k21method66 = (x^16 - x^15 + x^14 - x^9 - 2*x^8 - x^7 + x^2 + 2*x + 1)/3
P_k21method66 = 3*q_k21method66
rs.update({"k21method66" :  r_k21method66})
qs.update({"k21method66" :  q_k21method66})
ks.update({"k21method66" :  21})
Ps.update({"k21method66" : P_k21method66})
vs.update({"k21method66" : x})


k = 27 # rho=1.33 
t_k27method66 = x + 1
r_k27method66 = (x^18 + x^9 + 1)/3
q_k27method66 = (x^20 -2*x^19 + x^18 + x^11 - 2*x^10 + x^9 + x^2 + x + 1)/3
P_k27method66 = 3*q_k27method66
rs.update({"k27method66" :  r_k27method66})
qs.update({"k27method66" :  q_k27method66})
ks.update({"k27method66" :  27})
Ps.update({"k27method66" : P_k27method66})
vs.update({"k27method66" : x})


k = 33 # rho=1.2
r_k33method66 = x^20 + x^19 - x^17 - x^16 + x^14 + x^13 - x^11 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
q_k33method66 = (x^24 - x^23 + x^22 - x^13 - 2*x^12 - x^11 + x^2 + 2*x + 1)/3
P_k33method66 = 3*q_k33method66
rs.update({"k33method66" :  r_k33method66})
qs.update({"k33method66" :  q_k33method66})
ks.update({"k33method66" :  33})
Ps.update({"k33method66" : P_k33method66})
vs.update({"k33method66" : x})


k = 39 # rho= 1.1667
r_k39method66 = x^24 + x^23 - x^21 - x^20 + x^18 + x^17 - x^15 - x^14 + x^12 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
q_k39method66 = (x^28 - x^27 + x^26 - x^15 - 2*x^14 - x^13 + x^2 + 2*x + 1)/3
P_k39method66 = 3*q_k39method66
rs.update({"k39method66" :  r_k39method66})
qs.update({"k39method66" :  q_k39method66})
ks.update({"k39method66" :  39})
Ps.update({"k39method66" : P_k39method66})
vs.update({"k39method66" : x})
 

k = 45 # rho=1.33
r_k45method66 = x^24 + x^21 - x^15 - x^12 - x^9 + x^3 + 1 
q_k45method66 = (x^32 - x^31 + x^30 - x^17 - 2*x^16 - x^15 + x^2 + 2*x + 1)/3
P_k45method66 = 3*q_k45method66
rs.update({"k45method66" :  r_k45method66})
qs.update({"k45method66" :  q_k45method66})
ks.update({"k45method66" :  45})
Ps.update({"k45method66" : P_k45method66})
vs.update({"k45method66" : x})


k = 51 # rho=1.125
r_k51method66 = x^32 + x^31 - x^29 - x^28 + x^26 + x^25 - x^23 - x^22 + x^20 + x^19 - x^17 - x^16 - x^15 + x^13 + x^12 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
q_k51method66 = (x^36 - x^35 + x^34 - x^19 - 2*x^18 - x^17 + x^2 + 2*x + 1)/3  
P_k51method66 = 3*q_k51method66
rs.update({"k51method66" :  r_k51method66})
qs.update({"k51method66" :  q_k51method66})
ks.update({"k51method66" :  51})
Ps.update({"k51method66" : P_k51method66})
vs.update({"k51method66" : x})


# k = 4 mod 6, k = 16 in our parameters
#r = CyclotomicPolynomial(3*k)
# t = x^3 +1
# q = ((x^3-1)^2)*(x^k - x^(k / 2) + 1) / 3 + x^3


k= 10 # deg(r) = 8, deg(q) = 16 
# rho = 2
r_k10method66 = x^8 + x^7 - x^5 - x^4 - x^3 + x + 1              
q_k10method66 = (x^16 - 2*x^13 - x^11 + x^10 + 2*x^8 + x^6 - x^5 + x^3 + 1)  / 3
P_k10method66 = q_k10method66.numerator()
rs.update({"k10method66" :  r_k10method66})
qs.update({"k10method66" :  q_k10method66})
ks.update({"k10method66" :  10})
Ps.update({"k10method66" : P_k10method66})
vs.update({"k10method66" : x})


k= 16 # deg(r) = 16, deg(q) = 22 
rho = 1,375
r_k16method66 = x^16 - x^8 + 1
t_k16method66 = x^3 + 1
q_k16method66 = (x^22 - 2*x^19 + x^16 - x^14 + 2*x^11 - x^8 + x^6 +x^3 + 1)  / 3
P_k16method66 = q_k16method66.numerator()
rs.update({"k16method66" :  r_k16method66})
qs.update({"k16method66" :  q_k16method66})
ks.update({"k16method66" :  16})
Ps.update({"k16method66" : P_k16method66})
vs.update({"k16method66" : x})


k = 22 # rho = 1.4 
r_k22method66 = x^20 + x^19 - x^17 - x^16 + x^14 + x^13 - x^11 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
q_k22method66 = x^28 - 2*x^25 + x^22 - x^17 + 2*x^14 - x^11 + x^6 + x^3 + 1
P_k22method66 = 3*q_k22method66
rs.update({"k22method66" :  r_k22method66})
qs.update({"k22method66" :  q_k22method66})
ks.update({"k22method66" :  22})
Ps.update({"k22method66" : P_k22method66})
vs.update({"k22method66" : x})


k = 28 # rho=1.4167 
r_k28method66 = x^24 + x^22 - x^18 - x^16 + x^12 - x^8 - x^6 + x^2 + 1
q_k28method66 = (x^34 - 2*x^31 + x^28 - x^20 + 2*x^17 - x^14 + x^6 + x^3 + 1)/3 
P_k28method66 = 3*q_k28method66
rs.update({"k28method66" :  r_k28method66})
qs.update({"k28method66" :  q_k28method66})
ks.update({"k28method66" :  28})
Ps.update({"k28method66" : P_k28method66})
vs.update({"k28method66" : x})


k = 34 # rho=1.25
r_k34method66 = x^32 + x^31 - x^29 - x^28 + x^26 + x^25 - x^23 - x^22 + x^20 + x^19 - x^17 - x^16 - x^15 + x^13 + x^12 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1 
q_k34method66 = (x^40 - 2*x^37 + x^34 - x^23 + 2*x^20 - x^17 + x^6 + x^3 + 1)/3 
P_k34method66 = 3*q_k34method66
rs.update({"k34method66" :  r_k34method66})
qs.update({"k34method66" :  q_k34method66})
ks.update({"k34method66" :  34})
Ps.update({"k34method66" : P_k34method66})
vs.update({"k34method66" : x})


k = 40 # rho=1.4375
r_k40method66 = x^32 + x^28 - x^20 - x^16 - x^12 + x^4 + 1
q_k40method66 = (x^46 - 2*x^43 + x^40 - x^26 + 2*x^23 - x^20 + x^6 + x^3 + 1)/3
P_k40method66 = 3*q_k40method66
rs.update({"k40method66" :  r_k40method66})
qs.update({"k40method66" :  q_k40method66})
ks.update({"k40method66" :  40})
Ps.update({"k40method66" : P_k40method66})
vs.update({"k40method66" : x})


k = 46 # rho=1.1818
r_k46method66 = x^44 + x^43 - x^41 - x^40 + x^38 + x^37 - x^35 - x^34 + x^32 + x^31 - x^29 - x^28 + x^26 + x^25 - x^23 - x^22 - x^21 + x^19 + x^18 - x^16 - x^15 + x^13 + x^12 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
q_k46method66 = (x^52 - 2*x^49 + x^46 - x^29 + 2*x^26 - x^23 + x^6 + x^3 + 1)/3
P_k46method66 = 3*q_k46method66
rs.update({"k46method66" :  r_k46method66})
qs.update({"k46method66" :  q_k46method66})
ks.update({"k46method66" :  46})
Ps.update({"k46method66" : P_k46method66})
vs.update({"k46method66" : x})


k = 52 # rho 
r_k52method66 = x^48 + x^46 - x^42 - x^40 + x^36 + x^34 - x^30 - x^28 + x^24 - x^20 - x^18 + x^14 + x^12 - x^8 - x^6 + x^2 + 1
q_k52method66 = x^58 - 2*x^55 + x^52 - x^32 + 2*x^29 - x^26 + x^6 + x^3 + 1
P_k52method66 = 3*q_k52method66
rs.update({"k52method66" :  r_k52method66})
qs.update({"k52method66" :  q_k52method66})
ks.update({"k52method66" :  52})
Ps.update({"k52method66" : P_k52method66})
vs.update({"k52method66" : x})


# k = 5 mod 6, k = 11, 19 in our parameters
#r = CyclotomicPolynomial(6*k)
# t = x^(k+1)+1
# q = (x^2 - x + 1)*(x^(2*k) - x^k + 1) / 3 + x^(k+1)

k= 11 # deg(r) = 20, deg(q) = 24 
rho = 1,20
r_k11method66 = x^20 + x^19 - x^17 - x^16 + x^14 + x^13 - x^11 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
t_k11method66 = x^12 + 1
q_k11method66 = (x^24 - x^23 + x^22 - x^13 + 4*x^12 - x^11 + x^2 -x + 1)  / 3
P_k11method66 = 3*q_k11method66

rs.update({"k11method66" :  r_k11method66})
qs.update({"k11method66" :  q_k11method66})
ks.update({"k11method66" :  11})
Ps.update({"k11method66" : P_k11method66})
vs.update({"k11method66" : x})

k= 17 # deg(r) = 32, deg(q) =  , EulerPhi(19)=16;
rho = 1.111
r_k17method66 = x^32 + x^31 - x^29 - x^28 + x^26 + x^25 - x^23 - x^22 + x^20 + x^19 - x^17 - x^16 - x^15 + x^13 + x^12 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1

t_k17method66 = x^18 + 1
q_k17method66 = (x^36 - x^35 + x^34 - x^19 + 4*x^18 - x^17 + x^2 - x + 1)  / 3
P_k17method66 = 3*q_k17method66
# sage: (a+1/a).minpoly()
# x^18 - x^17 - 17*x^16 + 17*x^15 + 119*x^14 - 119*x^13 - 442*x^12 + 442*x^11 + 935*x^10 - 935*x^9 - 1122*x^8 + 1122*x^7 + 714*x^6 - 714*x^5 - 204*x^4 + 204*x^3 + 17*x^2 - 18*x + 4

rs.update({"k17method66" :  r_k17method66})
qs.update({"k17method66" :  q_k17method66})
ks.update({"k17method66" :  17})
Ps.update({"k17method66" : P_k17method66})
vs.update({"k17method66" : x})


k = 23 # rho = 1.0909
r_k23method66 = x^44 + x^43 - x^41 - x^40 + x^38 + x^37 - x^35 - x^34 + x^32 + x^31 - x^29 - x^28 + x^26 + x^25 - x^23 - x^22 - x^21 + x^19 + x^18 - x^16 - x^15 + x^13 + x^12 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
q_k23method66 = (x^48 - x^47 + x^46 - x^25 + 4*x^24 - x^23 + x^2 - x + 1)/3
P_k23method66 = 3*q_k23method66
rs.update({"k23method66" :  r_k23method66})
qs.update({"k23method66" :  q_k23method66})
ks.update({"k23method66" :  23})
Ps.update({"k23method66" : P_k23method66})
vs.update({"k23method66" : x})


k = 29 # rho = 1.0714 
r_k29method66 = x^56 + x^55 - x^53 - x^52 + x^50 + x^49 - x^47 - x^46 + x^44 + x^43 - x^41 - x^40 + x^38 + x^37 - x^35 - x^34 + x^32 + x^31 - x^29 - x^28 - x^27 + x^25 + x^24 - x^22 - x^21 + x^19 + x^18 - x^16 - x^15 + x^13 + x^12 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
q_k29method66 = (x^60 - x^59 + x^58 - x^31 + 4*x^30 - x^29 + x^2 - x + 1)/3
P_k29method66 = 3*q_k29method66
rs.update({"k29method66" :  r_k29method66})
qs.update({"k29method66" :  q_k29method66})
ks.update({"k29method66" :  29})
Ps.update({"k29method66" : P_k29method66})
vs.update({"k29method66" : x})


k = 35 # rho = 1.5
r_k35method66 = x^48 - x^47 + x^46 + x^43 - x^42 + 2*x^41 - x^40 + x^39 + x^36 - x^35 + x^34 - x^33 + x^32 - x^31 - x^28 - x^26 - x^24 - x^22 - x^20 - x^17 + x^16 - x^15 + x^14 - x^13 + x^12 + x^9 - x^8 + 2*x^7 - x^6 + x^5 + x^2 - x + 1
q_k35method66 = (x^72 - x^71 + x^70 - x^37 + 4*x^36 - x^35 + x^2 - x + 1)/3
P_k35method66 = 3*q_k35method66
rs.update({"k35method66" :  r_k35method66})
qs.update({"k35method66" :  q_k35method66})
ks.update({"k35method66" :  35})
Ps.update({"k35method66" : P_k35method66})
vs.update({"k35method66" : x})


k = 41 # rho 1.05
r_k41method66 = x^80 + x^79 - x^77 - x^76 + x^74 + x^73 - x^71 - x^70 + x^68 + x^67 - x^65 - x^64 + x^62 + x^61 - x^59 - x^58 + x^56 + x^55 - x^53 - x^52 + x^50 + x^49 - x^47 - x^46 + x^44 + x^43 - x^41 - x^40 - x^39 + x^37 + x^36 - x^34 - x^33 + x^31 + x^30 - x^28 - x^27 + x^25 + x^24 - x^22 - x^21 + x^19 + x^18 - x^16 - x^15 + x^13 + x^12 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
q_k41method66 = (x^84 - x^83 + x^82 - x^43 + 4*x^42 - x^41 + x^2 - x + 1)/3 
P_k41method66 = 3*q_k41method66
rs.update({"k41method66" :  r_k41method66})
qs.update({"k41method66" :  q_k41method66})
ks.update({"k41method66" :  41})
Ps.update({"k41method66" : P_k41method66})
vs.update({"k41method66" : x})


k = 47 # rho=1.0435
r_k47method66 = x^92 + x^91 - x^89 - x^88 + x^86 + x^85 - x^83 - x^82 + x^80 + x^79 - x^77 - x^76 + x^74 + x^73 - x^71 - x^70 + x^68 + x^67 - x^65 - x^64 + x^62 + x^61 - x^59 - x^58 + x^56 + x^55 - x^53 - x^52 + x^50 + x^49 - x^47 - x^46 - x^45 + x^43 + x^42 - x^40 - x^39 + x^37 + x^36 - x^34 - x^33 + x^31 + x^30 - x^28 - x^27 + x^25 + x^24 - x^22 - x^21 + x^19 + x^18 - x^16 - x^15 + x^13 + x^12 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
q_k47method66 = (x^96 - x^95 + x^94 - x^49 + 4*x^48 - x^47 + x^2 - x + 1)/3
P_k47method66 = 3*q_k47method66
rs.update({"k47method66" :  r_k47method66})
qs.update({"k47method66" :  q_k47method66})
ks.update({"k47method66" :  47})
Ps.update({"k47method66" : P_k47method66})
vs.update({"k47method66" : x})



k = 53 #
r_k53method66 = x^104 + x^103 - x^101 - x^100 + x^98 + x^97 - x^95 - x^94 + x^92 + x^91 - x^89 - x^88 + x^86 + x^85 - x^83 - x^82 + x^80 + x^79 - x^77 - x^76 + x^74 + x^73 - x^71 - x^70 + x^68 + x^67 - x^65 - x^64 + x^62 + x^61 - x^59 - x^58 + x^56 + x^55 - x^53 - x^52 - x^51 + x^49 + x^48 - x^46 - x^45 + x^43 + x^42 - x^40 - x^39 + x^37 + x^36 - x^34 - x^33 + x^31 + x^30 - x^28 - x^27 + x^25 + x^24 - x^22 - x^21 + x^19 + x^18 - x^16 - x^15 + x^13 + x^12 - x^10 - x^9 + x^7 + x^6 - x^4 - x^3 + x + 1
q_k53method66 = (x^108 - x^107 + x^106 - x^55 + 4*x^54 - x^53 + x^2 - x + 1)/3
P_k53method66 = 3*q_k53method66
rs.update({"k53method66" :  r_k53method66})
qs.update({"k53method66" :  q_k53method66})
ks.update({"k53method66" :  53})
Ps.update({"k53method66" : P_k53method66})
vs.update({"k53method66" : x})

#-----------------------------------------------------------------------------



#----------------------------------- method 6.7------------------------------- 
# k such that  k = 0 mod 3, k= 12, 15, 18, 21 ? for our value
# D = 2
# l =Lcm(8,k)
# rho = (5*k/12+2.)/EulerPhi(k) #if k even
# rho = (5*k/6 +4.)/EulerPhi(k)# if k is odd
#r = CyclotomicPolynomial(l)
#q = (2* (x^(l / k)+1)^2 + ((1-x^(l / k))^2)*((x^(5*(l / 24)) + x^(l / 8) - x^(l / 24))^2)) / 8 
# t = x^(l / k) +1


k = 9
l = lcm(8,9) 
r_k9method67 = x^24 - x^12 + 1
q_k9method67 = (2* (x^8+1)^2 + (1-x^8)^2*(x^15 + x^9 - x^3)^2) / 8 
P_k9method67 = x^23 + 2*x^20 - 2*x^19 - x^17 - 4*x^16 + x^15 - 2*x^14 + 2*x^13 + 2*x^12 + x^11 + 4*x^10 - x^9 + 2*x^8 - 2*x^7 - 2*x^6 + 4*x^4 + x^3 + 2
t_k9method67 = x^8 + 1
rs.update({"k9method67" :  r_k9method67})
qs.update({"k9method67" :  q_k9method67})
ks.update({"k9method67" :  9})
Ps.update({"k9method67" : P_k9method67})
vs.update({"k9method67" : x^2})



k= 12
# rho = 1,75, deg(q) = 14, deg(r) = 8
r_k12method67= x^8 - x^4 + 1 
q_k12method67 = (2* (x^2+1)^2 + ((1-x^2)^2)*((x^5 + x^3 - x)^2)) / 8 
P_k12method67 = 2* (x+1)^2 + ((1-x)^2)*((x^2 + x - 1)^2*x)
t_k12method67 = x^2 + 1  # x^(l/k)+1
rs.update({"k12method67" :  r_k12method67})
qs.update({"k12method67" :  q_k12method67})
ks.update({"k12method67" :  12})
Ps.update({"k12method67" : P_k12method67})
vs.update({"k12method67" : x^2})


k = 15
# deg(r) = 32, deg(q) = 66 
# rho = 2,062
r_k15method67 =x^32 + x^28 - x^20 - x^16 - x^12 + x^4 + 1
t_k15method67 = x^8 + 1
q_k15method67 = (2* (x^8+1)^2 + (1-x^8)^2*(x^25  + x^15 - x^5)^2) / 8 
P_k15method67 = 2* (x^4+1)^2 + (1-x^4)^2*(x^10  + x^5 - 1)^2*x^5
rs.update({"k15method67" :  r_k15method67})
qs.update({"k15method67" :  q_k15method67})
ks.update({"k15method67" :  15})
Ps.update({"k15method67" : P_k15method67})
vs.update({"k15method67" : x^2})



k = 18
# deg(r) = 24, deg(q)= 38 
# rho = 1,58333
r_k18method67= x^24 - x^12 + 1
q_k18method67 = (2* (x^4+1)^2 + ((1-x^4)^2)*((x^15 + x^9 - x^3)^2)) / 8
P_k18method67 = 8*q_k18method67
t_k18method67 = x^4 + 1  
rs.update({"k18method67" :  r_k18method67})
qs.update({"k18method67" :  q_k18method67})
ks.update({"k18method67" :  18})
Ps.update({"k18method67" : P_k18method67})
vs.update({"k18method67" : x^2})



k = 21
# deg(r) = 48, deg(q) = 86 
# rho = 1,79
r_k21method67 = x^48 + x^44 - x^36 - x^32 + x^24 - x^16 - x^12 + x^4 + 1
t_k21method67 = x^8 + 1
q_k21method67 = (2* (x^8+1)^2 + (1-x^8)^2*(x^35  + x^21 - x^7)^2) / 8 
P_k21method67 = 2* (x^4+1)^2 + (1-x^4)^2*(x^14  + x^7 - 1)^2*x^7
rs.update({"k21method67" :  r_k21method67})
qs.update({"k21method67" :  q_k21method67})
ks.update({"k21method67" :  21})
Ps.update({"k21method67" : P_k21method67})
vs.update({"k21method67" : x^2})


k = 24 # rho=1.5 
r_k24method67 = x^8 - x^4 + 1
q_k24method67 = (x^12 - 2*x^11 + 3*x^10 - 4*x^9 + x^8 + 2*x^7 - 3*x^6 + 4*x^5 - x^4 - 2*x^3 + 3*x^2 + 4*x + 2)/8
P_k24method67 = 8*q_k24method67
rs.update({"k24method67" :  r_k24method67})
qs.update({"k24method67" :  q_k24method67})
ks.update({"k24method67" :  24})
Ps.update({"k24method67" : P_k24method67})
vs.update({"k24method67" : x})

k = 27 # rho=1.4722
r_k27method67 = x^72 - x^36 + 1
q_k27method67 = (x^106 - 2*x^98 + x^90 + 2*x^88 - 4*x^80 + 2*x^72 - x^70 + 2*x^62 - x^54 - 2*x^52 + 4*x^44 - 2*x^36 + x^34 - 2*x^26 + x^18 + 2*x^16 + 4*x^8 + 2)/8
P_k27method67 = 8*q_k27method67
rs.update({"k27method67" :  r_k27method67})
qs.update({"k27method67" :  q_k27method67})
ks.update({"k27method67" :  27})
Ps.update({"k27method67" : P_k27method67})
vs.update({"k27method67" : x})


k = 30 # rho=1.8125
r_k30method67 = x^32 + x^28 - x^20 - x^16 - x^12 + x^4 + 1 
q_k30method67 = (x^58 - 2*x^54 + x^50 + 2*x^48 - 4*x^44 + 2*x^40 - x^38 + 2*x^34 - x^30 - 2*x^28 + 4*x^24 - 2*x^20 + x^18 - 2*x^14 + x^10 + 2*x^8 + 4*x^4 + 2)/8
P_k30method67 = 8*q_k30method67
rs.update({"k30method67" :  r_k30method67})
qs.update({"k30method67" :  q_k30method67})
ks.update({"k30method67" :  30})
Ps.update({"k30method67" : P_k30method67})
vs.update({"k30method67" : x})


k = 33 # rho=1.575      
r_k33method67 = x^80 + x^76 - x^68 - x^64 + x^56 + x^52 - x^44 - x^40 - x^36 + x^28 + x^24 - x^16 - x^12 + x^4 + 1                                           
q_k33method67 = (x^126 - 2*x^118 + x^110 + 2*x^104 - 4*x^96 + 2*x^88 - x^82 + 2*x^74 - x^66 - 2*x^60 + 4*x^52 - 2*x^44 + x^38 - 2*x^30 + x^22 + 2*x^16 + 4*x^8 + 2)/8
P_k33method67 = q_k33method67.numerator()
rs.update({"k33method67" :  r_k33method67})
qs.update({"k33method67" :  q_k33method67})
ks.update({"k33method67" :  33})
Ps.update({"k33method67" : P_k33method67})
vs.update({"k33method67" : x})


k = 36 # rho=1.4167      
r_k36method67 = x^24 - x^12 + 1                                           
q_k36method67 = (x^34 - 2*x^32 + x^30 + 2*x^28 - 4*x^26 + 2*x^24 - x^22 + 2*x^20 - x^18 - 2*x^16 + 4*x^14 - 2*x^12 + x^10 - 2*x^8 + x^6 + 2*x^4 + 4*x^2 + 2)/8
P_k36method67 = q_k36method67.numerator()
rs.update({"k36method67" :  r_k36method67})
qs.update({"k36method67" :  q_k36method67})
ks.update({"k36method67" :  36})
Ps.update({"k36method67" : P_k36method67})
vs.update({"k36method67" : x})


k = 39 # rho=1.520834     
r_k39method67 = x^96 + x^92 - x^84 - x^80 + x^72 + x^68 - x^60 - x^56 + x^48 - x^40 - x^36 + x^28 + x^24 - x^16 - x^12 + x^4 + 1
q_k39method67 = (x^146 - 2*x^138 + x^130 + 2*x^120 - 4*x^112 + 2*x^104 - x^94 + 2*x^86 - x^78 - 2*x^68 + 4*x^60 - 2*x^52 + x^42 - 2*x^34 + x^26 + 2*x^16 + 4*x^8 + 2)/8
P_k39method67 = q_k39method67.numerator()
rs.update({"k39method67" :  r_k39method67})
qs.update({"k39method67" :  q_k39method67})
ks.update({"k39method67" :  39})
Ps.update({"k39method67" : P_k39method67})
vs.update({"k39method67" : x})


k = 42 # rho=1.625     
r_k42method67 = x^48 + x^44 - x^36 - x^32 + x^24 - x^16 - x^12 + x^4 + 1
q_k42method67 = (x^78 - 2*x^74 + x^70 + 2*x^64 - 4*x^60 + 2*x^56 - x^50 + 2*x^46 - x^42 - 2*x^36 + 4*x^32 - 2*x^28 + x^22 - 2*x^18 + x^14 + 2*x^8 + 4*x^4 + 2)/8
P_k42method67 = q_k42method67.numerator()
rs.update({"k42method67" :  r_k42method67})
qs.update({"k42method67" :  q_k42method67})
ks.update({"k42method67" :  42})
Ps.update({"k42method67" : P_k42method67})
vs.update({"k42method67" : x})


k = 45 # rho= 1.729167     
r_k45method67 = x^96 + x^84 - x^60 - x^48 - x^36 + x^12 + 1
q_k45method67 = (x^166 - 2*x^158 + x^150 + 2*x^136 - 4*x^128 + 2*x^120 - x^106 + 2*x^98 - x^90 - 2*x^76 + 4*x^68 - 2*x^60 + x^46 - 2*x^38 + x^30 + 2*x^16 + 4*x^8 + 2)/8
P_k45method67 = q_k45method67.numerator()
rs.update({"k45method67" :  r_k45method67})
qs.update({"k45method67" :  q_k45method67})
ks.update({"k45method67" :  45})
Ps.update({"k45method67" : P_k45method67})
vs.update({"k45method67" : x})


k = 48 # rho=1.375      
r_k48method67 = x^16 - x^8 + 1                                           
q_k48method67 = (x^22 - 2*x^21 + x^20 + 2*x^18 - 4*x^17 + 2*x^16 - x^14 + 2*x^13 - x^12 - 2*x^10 + 4*x^9 - 2*x^8 + x^6 - 2*x^5 + x^4 + 2*x^2 + 4*x + 2
)/8
P_k48method67 = q_k48method67.numerator()
rs.update({"k48method67" :  r_k48method67})
qs.update({"k48method67" :  q_k48method67})
ks.update({"k48method67" :  48})
Ps.update({"k48method67" : P_k48method67})
vs.update({"k48method67" : x})


k = 51 # rho=1.453125      
r_k51method67 = x^128 + x^124 - x^116 - x^112 + x^104 + x^100 - x^92 - x^88 + x^80 + x^76 - x^68 - x^64 - x^60 + x^52 + x^48 - x^40 - x^36 + x^28 + x^24 - x^16 - x^12 + x^4 + 1                                           
q_k51method67 = (x^186 - 2*x^178 + x^170 + 2*x^152 - 4*x^144 + 2*x^136 - x^118 + 2*x^110 - x^102 - 2*x^84 + 4*x^76 - 2*x^68 + x^50 - 2*x^42 + x^34 + 2*x^16 + 4*x^8 + 2)/8
P_k51method67 = q_k51method67.numerator()
rs.update({"k51method67" :  r_k51method67})
qs.update({"k51method67" :  q_k51method67})
ks.update({"k51method67" :  51})
Ps.update({"k51method67" : P_k51method67})
vs.update({"k51method67" : x})


k = 54 # rho=      
r_k54method67 = x^72 - x^36 + 1                                           
q_k54method67 = (x^98 - 2*x^94 + x^90 + 2*x^80 - 4*x^76 + 2*x^72 - x^62 + 2*x^58 - x^54 - 2*x^44 + 4*x^40 - 2*x^36 + x^26 - 2*x^22 + x^18 + 2*x^8 + 4*x^4 + 2)/8
P_k54method67 = q_k54method67.numerator()
rs.update({"k54method67" :  r_k54method67})
qs.update({"k54method67" :  q_k54method67})
ks.update({"k54method67" :  54})
Ps.update({"k54method67" : P_k54method67})
vs.update({"k54method67" : x})

#-----------------------------------------------------------------------------



#---------------------------------method 6.8  BN -----------------------------
# Barreto Naehrig
#n=12, D=3, deg(r(x))=4, rho = 1 
# courbes BN, log_2(q) = 4096/12 = 341
# log_2(x) = 341/4 = 85

r_BN= 36*x^4+36*x^3+18*x^2+6*x+1
q_BN = 36*x^4+36*x^3+24*x^2+6*x+1
P_BN = q_BN
t_BN= 6*x^2+1
rs.update({"BN" :  r_BN})
qs.update({"BN" :  q_BN})
ks.update({"BN" :  12})
Ps.update({"BN" : P_BN})
vs.update({"BN" : x})
#-----------------------------------------------------------------------------


#--------------------------------- method KSS16 ------------------------------
# KSS
# k:=16; D:= 1; rho :=1,25;
# KSS 16

r_k16methodKSS = (x^8+48*x^4+625)/61250
q_k16methodKSS = (x^10 + 2*x^9 + 5*x^8 + 48*x^6 + 152*x^5 + 240*x^4 + 625*x^2 + 2398*x+3125) / 980
P_k16methodKSS = q_k16methodKSS.numerator()(x-1)
t_k16methodKSS = (2*x^5 + 41*x +35) / 35

rs.update({"k16methodKSS" :  r_k16methodKSS})
qs.update({"k16methodKSS" :  q_k16methodKSS})
ks.update({"k16methodKSS" :  16})
Ps.update({"k16methodKSS" : P_k16methodKSS})
vs.update({"k16methodKSS" : x+1})
#-----------------------------------------------------------------------------


#--------------------------------- method KSS18 ------------------------------
# KSS
# k:=18; D:= 3; rho :=1,333;

r_k18methodKSS = (x^6 + 37*x^3 + 343 )/ 343 
q_k18methodKSS = (x^8 + 5*x^7 + 7*x^6 + 37*x^5+188*x^4 + 259*x^3 + 343*x^2 + 1763*x + 2401) / 21
P_k18methodKSS = q_k18methodKSS.numerator()(x-2)
t_k18methodKSS = (x^4 + 16*x + 7) / 7

rs.update({"k18methodKSS" :  r_k18methodKSS})
qs.update({"k18methodKSS" :  q_k18methodKSS})
ks.update({"k18methodKSS" :  18})
Ps.update({"k18methodKSS" : P_k18methodKSS})
vs.update({"k18methodKSS" : x+2})
#-----------------------------------------------------------------------------


#--------------------------------- KSS 32 ------------------------------------
# KSS
# k:=32; D:= 1; rho :=1,125;

r_k32methodKSS = (x^16+57120*x^8+815730721)/93190709028482    
q_k32methodKSS = (x^18-6*x^17+13*x^16+57120*x^10-344632*x^9+742560*x^8+815730721*x^2-4948305594*x+10604499373) / 2970292 
P_k32methodKSS = q_k32methodKSS.numerator()
t_k32methodKSS = (x^4 + 16*x + 7) / 3107

rs.update({"k32methodKSS" :  r_k32methodKSS})
qs.update({"k32methodKSS" :  q_k32methodKSS})
ks.update({"k32methodKSS" :  32})
Ps.update({"k32methodKSS" : P_k32methodKSS})
vs.update({"k32methodKSS" : x})
#-----------------------------------------------------------------------------


#--------------------------------- method 6.14  KSS36 ------------------------
# KSS
# k:=36; D:= 3; rho :=1,1667;

r_k36methodKSS = (x^12+683*x^6+117649)/161061481
q_k36methodKSS = (x^14-4*x^13+7*x^12+683*x^8-2510*x^7+4781*x^6+117649*x^2-386569*x+823543) / 28749
P_k36methodKSS = q_k36methodKSS.numerator()(x+1)
t_k36methodKSS = (2*x^7 + 757*x + 259) / 259

rs.update({"k36methodKSS" :  r_k36methodKSS})
qs.update({"k36methodKSS" :  q_k36methodKSS})
ks.update({"k36methodKSS" :  36})
Ps.update({"k36methodKSS" : P_k36methodKSS})
vs.update({"k36methodKSS" : x-1})
#-----------------------------------------------------------------------------


#--------------------------------- method 6.15  KSS 40------------------------
# KSS
# k:=40; D:= 3; rho :=1,3750;

r_k40methodKSS = ( x^16 + 8*x^14 + 39*x^12 + 112*x^10 - 79*x^8 + 2800*x^6 + 24375*x^4 + 125000*x^2 + 390625 ) / 2437890625 
q_k40methodKSS = (x^22 - 2*x^21 + 5*x^20 + 6232*x^12 - 10568*x^11 + 31160*x^10 + 9765625*x^2 - 13398638*x + 48828125 ) / 1123380 
P_k40methodKSS = q_k18methodKSS.numerator()
t_k40methodKSS = (2*x^11 + 6469*x + 1185) / 1185

rs.update({"k40methodKSS" :  r_k40methodKSS})
qs.update({"k40methodKSS" :  q_k40methodKSS})
ks.update({"k40methodKSS" :  40})
Ps.update({"k40methodKSS" : P_k40methodKSS})
vs.update({"k40methodKSS" : x})
#-----------------------------------------------------------------------------



#----------------------------- method 6.20----------------------------------
#k odd, so k = 11, 15, (19 problem)
#D = 1
# rho = (k+1)/EulerPhi(k)
#r = CyclotomicPolynomial(4*k)
# q= (x^(2*k+2) + x^(2*k) + 4*((-1)^((k+1) / 2))*x^(k+1) + x^2 + 1  ) / 4
#t = 1 + (-1)^((k+1) / 2)*x^(k+1)


r_k11method620 = x^10 - x^9 + x^8 - x^7 + x^6 - x^5 + x^4 - x^3 + x^2 - x + 1
q_k11method620 = (x^12 + x^11 + 4*x^6 + x + 1)/4
P_k11method620 = x^6 + x^5 - 6*x^4 - 5*x^3 + 9*x^2 + 5*x + 2
rs.update({"k11method620" :  r_k11method620})
qs.update({"k11method620" :  q_k11method620})
ks.update({"k11method620" :  11})
Ps.update({"k11method620" : P_k11method620})
vs.update({"k11method620" : x+1/x})


r_k15method620 = x^8 + x^7 - x^5 - x^4 - x^3 + x + 1
q_k15method620 = (x^16 + x^15 + 4*x^8 + x + 1) / 4
P_k15method620 = x^8 + x^7 - 8*x^6 - 7*x^5 + 20*x^4 + 14*x^3 - 16*x^2 - 7*x + 6
rs.update({"k15method620" :  r_k15method620})
qs.update({"k15method620" :  q_k15method620})
ks.update({"k15method620" :  15})
Ps.update({"k15method620" : P_k15method620})
vs.update({"k15method620" : x+1/x})

#-----------------------------------------------------------------------------

#-----------------------------k18 method 6.24----------------------------------

#k odd =1 mod 4, k_prime = 2*k, can be used for k_prime = 10 and 18
# D = 1
# rho = (k+1)/EulerPhi(k)
#r = CyclotomicPolynomial(4*k)
# t = 1 -(-1)^((k+1) / 2)*x^(k+1)
# a = 3
# q = (a^(k+1)*x^(2*k+2) + a^k*x^(2*k) - 4*(-a)^((k+1) / 2)*x^(k+1) + a*x^2 +1) / 4


#k= 5 #deg(r) = 8, deg(q)= 12 
rho = 1,5
r_k10method624 = 3^4*x^8 - 3^3*x^6 + 3^2*x^4 - 3*x^2 + 1
q_k10method624 =  (729*x^12 + 243*x^10 + 108*x^6 + 3*x^2 + 1)  / 4 
P_k10method624 = x^3 + x^2 - 3*x + 2
t_k10method624 = -3^4*x^8 + 1 
rs.update({"k10method624" :  r_k10method624})
qs.update({"k10method624" :  q_k10method624})
ks.update({"k10method624" :  10})
Ps.update({"k10method624" : P_k10method624})
vs.update({"k10method624" : 3*x^2+1/(3*x^2)})


#k= 9 #deg(r) = 12, deg(q)= 20 
rho = 1,66
r_k18method624= 3^6*x^12 - 3^3*x^6 + 1
q_k18method624 = (59049*x^20 + 19683*x^18 + 972*x^10 + 3*x^2 + 1) / 4
P_k18method624 = x^5 + x^4 - 5*x^3 - 4*x^2 + 5*x + 6 
t_k18method624 = 3^5*x^10 + 1
rs.update({"k18method624" :  r_k18method624})
qs.update({"k18method624" :  q_k18method624})
ks.update({"k18method624" :  18})
Ps.update({"k18method624" : P_k18method624})
vs.update({"k18method624" : 3*x^2+1/(3*x^2)})


k = 13 # rho=1.1667
r_k26method624 = x^24 - x^22 + x^20 -x^18 + x^16 - x^14 + x^12 - x^10 + x^8 - x^6 + x^4 - x^2 + 1
q_k26method624 = (4782969*x^28 + 1594323*x^26 + 8748*x^14 + 3*x^2 + 1 ) / 4
P_k26method624 =  x^7 + x^6 - 7*x^5 - 6*x^4 + 14*x^3 + 9*x^2 - 7*x + 2
rs.update({"k26method624" :  r_k26method624})
qs.update({"k26method624" :  q_k26method624})
ks.update({"k26method624" :  26})
Ps.update({"k26method624" : P_k26method624})
vs.update({"k26method624" : 3*x^2+1/(3*x^2)})


k = 17 # rho=1.125
r_k34method624 = x^32-x^30+x^28-x^26+x^24-x^22+x^20-x^18+x^16-x^14+x^12-x^10+x^8-x^6+x^4-x^2+1       
q_k34method624 = (387420489*x^36+129140163*x^34+70732*x^10+3*x^2+1 ) / 4
P_k34method624 = x^9 + x^8 - 9*x^7 - 8*x^6 + 27*x^5 + 20*x^4 - 30*x^3-16*x^2+9*x+6                                                    
rs.update({"k34method624" :  r_k34method624})
qs.update({"k34method624" :  q_k34method624})
ks.update({"k34method624" :  34})
Ps.update({"k34method624" : P_k34method624})
vs.update({"k34method624" : 3*x^2+1/(3*x^2)})



#-----------------------------------------------------------------------------

#----------------------------------------KSS 54--------------------------------
k=54

rho = 1.11
r_KSS54 = 1+3*5*x^9+3^9*x^18 
q_KSS54 = 3^10*x^20+3^10*x^19+3^9*x^18+3^6*x^11+(3^5+3^6)*x^10+3^5*x^9+3*x^2+3*x+1
P_KSS54 = q_KSS54                                   
t_KSS54 = 1+3^5*x^10            
rs.update({"KSS54" :  r_KSS54})
qs.update({"KSS54" :  q_KSS54})
ks.update({"KSS54" :  54})
Ps.update({"KSS54" : P_KSS54})
vs.update({"KSS54" : x})
